/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:bracket.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include "ed.h"

#define	BRACKET1	1
#define	BRACKET2	2
#define	NON		0

static int
SearchSetDraw(LineOffset, ColOffset, targetlen)
register long LineOffset;
register int ColOffset;
register int targetlen;
{
	register int DrawFlag;
	register int tmpscroll;
	DrawFlag = FALSE;

	tmpscroll = GetScroll();

	if (LineOffset != GetLineOffset()) {
		if (LineOffset < GetLineOffset()) {
		/* target before current line */
			while (GetLineOffset() > LineOffset) {
				if (GetRow() > GetMinRow()) {
					CursorSetRow(GetRow()-1);
				} else {
					DrawFlag = TRUE;
				}
				LineOffsetUp();
			}
		} else {
		/* target after current line */
			while (GetLineOffset() < LineOffset) {
				if (GetRow() < GetMaxRow()-1) {
					CursorSetRow(GetRow()+1);
				} else {
					DrawFlag = TRUE;
				}
				LineOffsetDown();
			}
		}
	}
	if (ColOffset != GetBufferOffset()) {
		if (ColOffset < GetBufferOffset()) {
		/* target before current line */
			while (GetBufferOffset() > ColOffset) {
				ResetCursorPosition();
				BuffsetOffsetLeft();
				CursorLeft();
			}
		} else {
		/* target after current line */
			while (GetBufferOffset() < ColOffset+targetlen) {
				ResetCursorPosition();
				if (IsKanjiPosition()) {
					BufferOffsetRight();
					CursorRight();
					BufferOffsetRight();
					CursorRight();
				} else {
					BufferOffsetRight();
					CursorRight();
				}
			}
		}
	}
	LineOffsetSet(LineOffset);
	SetBufferOffset(ColOffset);
	CursorSetByColOffset();
	if (tmpscroll != GetScroll()) {
		DrawFlag = TRUE;
	}
	if (GetBlockFlg() == ONLINE) {
		DrawFlag = TRUE;
	}
	return DrawFlag;
}

static int
SearchSetDrawAndDraw(LineOffset, ColOffset, targetlen)
register long LineOffset;
register int ColOffset;
register int targetlen;
{
	if (LineOffset == GetLineOffset() && ColOffset == GetBufferOffset()) {
		return FALSE;
	}
	if (SearchSetDraw(LineOffset, ColOffset, targetlen) == TRUE) {
		CrtDrawAll();
	}
	return TRUE;
}

/*-------------------------------------------------------------------
	buffer
	target
-------------------------------------------------------------------*/
int
multiSearch_n(buffer, br1, br2, col)
char *buffer;
int br1;
int br2;
register int *col;
{
	register int i;
	register int colum;

	colum = *col;
	for (i = colum; buffer[i] != '\0'; i++) {
		if (buffer[i] == br1) {
			*col = i+1;
			return BRACKET1;
		} else if (buffer[i] == br2) {
			*col = i+1;
			return BRACKET2;
		}
	}
	return NON;
}

/*-------------------------------------------------------------------
-------------------------------------------------------------------*/
long
multiSearch_next(number, br1, br2, col)
register long number;
int br1;
int br2;
register int *col;
{
	int colum;
	register int res;
	register long num;
	register long LastOffset;
	register int bracket;
	register EditLine *ed;

	bracket = 1;
	num = number+1;
	ed = (EditLine *)GetList(number);
	LastOffset = GetLastNumber();
	colum = *col;
	do {
		res = multiSearch_n(ed->buffer, br1, br2, &colum);
		switch(res) {
		case BRACKET1:
			bracket++;
			break;
		case BRACKET2:
			bracket--;
			break;
		}
		if (bracket == 0) {
			*col = colum;
			return number;
		}
	} while (res != NON);
	if (num < LastOffset) {
		colum = 0;
		ed = ed->next;
		for (;;) {
			do {
				res = multiSearch_n(ed->buffer, br1, br2, &colum);
				switch(res) {
				case BRACKET1:
					bracket++;
					break;
				case BRACKET2:
					bracket--;
					break;
				}
				if (bracket == 0) {
					*col = colum;
					return num;
				}
			} while (res != NON);
			if (num+1 <= LastOffset) {
				colum = 0;
				num++;
				ed = ed->next;
			} else {
				return number;
			}
		}
	} else {
		return number;
	}
}

/*-------------------------------------------------------------------
	buffer
	target
-------------------------------------------------------------------*/
int
multiSearch_b(buffer, br1, br2, col)
char *buffer;
int br1;
int br2;
register int *col;
{
	register int i;
	register int colum;

	colum = min((int)strlen(buffer)-1, *col-2);
	if (*col < 2) {
		return NON;
	}
	for (i = colum; i >= 0; i--) {
		if (buffer[i] == br1) {
			*col = i+1;
			return BRACKET1;
		} else if (buffer[i] == br2) {
			*col = i+1;
			return BRACKET2;
		}
	}
	return NON;
}

/*-------------------------------------------------------------------
-------------------------------------------------------------------*/
long
multiSearch_behind(number, br1, br2, col)
register long number;
int br1;
int br2;
register int *col;
{
	int colum;
	register int res;
	register long num;
	register int bracket;
	register EditLine *ed;

	bracket = 1;
	ed = (EditLine *)GetList(number);
	colum = *col;
	do {
		res = multiSearch_b(ed->buffer, br1, br2, &colum);
		switch(res) {
		case BRACKET1:
			bracket--;
			break;
		case BRACKET2:
			bracket++;
			break;
		}
		if (bracket == 0) {
			*col = colum;
			return number;
		}
	} while (res != NON);
	num = number;
	for (;;) {
		num--;
		if (num > 0) {
			ed = ed->behind;
		} else {
			return number;
		}
		colum = strlen(ed->buffer)+1;
		do {
			res = multiSearch_b(ed->buffer, br1, br2, &colum);
			switch(res) {
			case BRACKET1:
				bracket--;
				break;
			case BRACKET2:
				bracket++;
				break;
			}
			if (bracket == 0) {
				*col = colum;
				return num;
			}

		/*colum--;*/
		} while (res != NON);
	}
}

int
BracketSearch(bracket)
int bracket;
{
	int ColOffset;
	register long LineOffset;

	LineOffset = GetLineOffset();
	ColOffset = GetBufferOffset();
	/*system_msg(SEARCHING_MSG);*/

	switch(bracket) {
	case '{':
		LineOffset = multiSearch_next(LineOffset, '{', '}', &ColOffset);
		break;
	case '[':
		LineOffset = multiSearch_next(LineOffset, '[', ']', &ColOffset);
		break;
	case '(':
		LineOffset = multiSearch_next(LineOffset, '(', ')', &ColOffset);
		break;
	case '<':
		LineOffset = multiSearch_next(LineOffset, '<', '>', &ColOffset);
		break;
	case '}':
		LineOffset = multiSearch_behind(LineOffset, '{', '}', &ColOffset);
		break;
	case ']':
		LineOffset = multiSearch_behind(LineOffset, '[', ']', &ColOffset);
		break;
	case ')':
		LineOffset = multiSearch_behind(LineOffset, '(', ')', &ColOffset);
		break;
	case '>':
		LineOffset = multiSearch_behind(LineOffset, '<', '>', &ColOffset);
		break;
	default:
		LineOffset = multiSearch_behind(LineOffset, '{', '}', &ColOffset);
		break;
	}
	if (SearchSetDrawAndDraw(LineOffset, ColOffset, 1) == FALSE) {
		system_msg(NOT_FOUND_MSG);
		return FALSE;
	}
	return TRUE;

}

int
BracketSearchOp()
{
	int bracket;
	register EditLine *ed;

	ed = (EditLine *)GetList(GetLineOffset());
	bracket = ed->buffer[ GetBufferOffset()-1 ];
	CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
	BracketSearch(bracket);
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
}
