/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:c_offset.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include <ctype.h>
#include "ed.h"

static int col_offset[MAXEDIT];

VOID
BufferOffsetInit()
{
	col_offset[CurrentFileNo] = 1;
}

VOID
BuffsetOffsetLeft()
{
	if (col_offset[CurrentFileNo] > 1) {
		col_offset[CurrentFileNo]--;
	}
}

VOID
BufferOffsetRight()
{
	col_offset[CurrentFileNo]++;
}

int
GetBufferOffset()
{
	return col_offset[CurrentFileNo];
}

VOID
SetBufferOffset(offset)
register int offset;
{
	if (offset > 0) {
		col_offset[CurrentFileNo] = offset;
	} else {
		col_offset[CurrentFileNo] = 1;
	}
	CursorSetByColOffset();
}
/*-------------------------------------------------------------------
	Get Buffer length at OffsetCol
-------------------------------------------------------------------*/
int
GetOffsetOfBuffer(LineNumber)
register long LineNumber;
{
	register int i;
	register int length;
	register int strlength;
	register EditLine *ed;

	ed = (EditLine *)GetList(LineNumber);
	strlength = strlen(ed->buffer);
	for (i = 0, length = 1; i < GetBufferOffset()-1; i++) {
		if (i < strlength) {
			if (ed->buffer[i] == '\t') {
				length = ((length-1)/TabStop+1)*TabStop+1;
			} else if (iscntrl((unsigned char)(ed->buffer[i]))) {
				length +=2;
			} else {
				length ++;
			}
		} else {
			length++;
		}
	}
	return length;
}

int
OffsetSetByColum(LineNumber)
register long LineNumber;
{
	register int i;
	register int length;
	register int cols;
	register int strlength;
	register EditLine *ed;

	ed = (EditLine *)GetList(LineNumber);

	cols = GetCorrectColumn(LineNumber);
	strlength = strlen(ed->buffer);

	for (i = 0, length = 1; length < cols; i++) {
		if (i < strlength) {
			if (ed->buffer[i] == '\t') {
				length = ((length-1)/TabStop+1)*TabStop+1;
			} else if (iscntrl((unsigned char)(ed->buffer[i]))) {
				length += 2;
			} else {
				length++;
			}
		} else {
			length++;
		}
	}

	SetBufferOffset(i+1);
}

/*-------------------------------------------------------------------
	Get Buffer Offset by Cursor Column
-------------------------------------------------------------------*/
int
OffsetGetByColum(LineNumber)
int	LineNumber;
{
	register int i;
	register int length;
	register int cols;
	register int strlength;
	register EditLine *ed;

	ed = (EditLine *)GetList(LineNumber);
	strlength = strlen(ed->buffer);
	if (CursorMode == FREE) {
		cols = GetCol()+GetScroll();
	} else {
		cols = GetCorrectColumn(LineNumber);
	}

	for (i = 0, length = 1; length < cols && i < strlength; i++) {
		if (ed->buffer[i] == '\t') {
			length = ((length/TabStop)+1)*TabStop+1;
		} else if (iscntrl((unsigned char)(ed->buffer[i]))) {
			length += 2;
		} else {
			length++;
		}
	}
	if (CursorMode == FREE) {
		for (; length <= cols; length++) {
			i++;
		}
	}
	return i;
}

/*-------------------------------------------------------------------
	Set Cursor Position by Buffer Offset
-------------------------------------------------------------------*/
VOID
SetPositionByOffset(offset)
int offset;
{
	int Column;
	SetBufferOffset(offset);
	Column = ColumnGetByOffset(offset);
	if (GetMinCol()+GetScroll() <= Column && Column <= GetMaxCol()+GetScroll()) {
		CursorSetCol(Column);
	} else if (GetMinCol()+GetScroll() > Column) {
		CursorSetScroll(GetScroll()-(GetScroll()-Column));
		CursorSetCol(Column+NumWidth);
	} else if (GetMaxCol()+GetScroll() < Column) {
		CursorSetScroll(Column-(GetMaxCol()-GetMinCol()));
		CursorSetCol(Column+NumWidth);
	}
}

VOID
ResetPosition()
{
	SetPositionByOffset(GetBufferOffset());
	ResetKanjiPosition();
}
