/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:crt.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include "ed.h"
#include <ctype.h>
#include <varargs.h>
/*-------------------------------------------------------------------
	Emulate mvprintw()
------------------------------------------------------------------*/
#ifndef NOVSPRINTF
/*VARARGS1*/
int
locate_cprintf(y, x, fmt, va_alist)
int y;
int x;
char *fmt;
va_dcl
{
	va_list args;
	int len;
	char buf[MAXLINESTR+1];

	va_start(args);
	locate(x, y);
	len = vsprintf(buf, fmt, args);
	va_end(args);
#else
locate_cprintf(y, x, fmt, arg1, arg2, arg3, arg4, arg5, arg6)
int y;
int x;
char *fmt;
{
	int len;
	char buf[MAXLINESTR+1];

	len = sprintf(buf, fmt, arg1, arg2, arg3, arg4, arg5, arg6);
#endif
	cputs(buf);
	return(len);
}

VOID
widthputs(s, len)
char *s;
int len;
{
	int i, p, c;
	int kanji1, prn;

	p = 0;
	for (i = 0; i < len && s[i]; i++);
	if (i < len) {
		cputs(s);
		for (; i < len; i++) putch(' ');
	} else {
		kanji1 = prn = 0;
		for (i = 0; i < len-1 ; i++) {
			putch(s[i]);
			if (kanji1) {
				kanji1 = 0;
			}
			else {
				kanji1 = IsKanji(s[i]);
			}
		}
		if (!kanji1 && IsKanji(s[i])) {
			putch(' ');
		} else {
			putch(s[i]);
		}
	}
}

/*-------------------------------------------------------------------
	Expand String
------------------------------------------------------------------*/
int
Tab_Space(s_buffer, d_buffer)
char *s_buffer;
char *d_buffer;
{

	register int s;	/* index */
	register int d;	/* index */
	register int t;
	register int i;
	for (s = 0, d = 0; s_buffer[s] != '\0' && d < MAXEDITLINE-2; s++, d++) {
		if (s_buffer[s] == '\t') {
			if (TabMark == TRUE) {
				d_buffer[d] = TabCode;
			} else {
				d_buffer[d] = ' ';
			}
			i = (d/TabStop+1)*TabStop;
			for (t = d+1; t <= i; t++) {
				d_buffer[t] = ' ';
			}
			d = i-1;
		} else if (iscntrl((unsigned char)(s_buffer[s]))) {
			d_buffer[d++] = '^';
			d_buffer[d] = s_buffer[s]+'@';
		} else {
			d_buffer[d] = s_buffer[s];
		}
	}
	if (CrMark == TRUE) {
		d_buffer[d++] = CrCode;
		d_buffer[d] = '\0';
	} else {
		d_buffer[d++] = ' ';
		d_buffer[d] = '\0';
	}
	return d;
}

/*-------------------------------------------------------------------
	Put edit line
-------------------------------------------------------------------*/
VOID
CrtDrawLine(row, LineOffset, isunder)
register int row;
register long LineOffset;
register int isunder;
{
	register int length;
	register int scroll;
	register long block_start;
	register long block_end;
	register int offset;

	char d_buffer[MAXEDITLINE+1];

	char *buffer;
	register EditLine *ed;

	block_start = GetBlockStart();
	block_end = GetBlockEnd();

	ed = (EditLine *)GetList(LineOffset);
	length = Tab_Space(ed->buffer, d_buffer);

	if (ed->next == NULL) {
		d_buffer[length-1] = '\0';
		strcat(d_buffer, "[EOF]");
	}
	buffer = d_buffer;
	scroll = GetScroll();
	if (0 < scroll) {
		if (scroll < length) {
			offset = scroll;
			if (IsThisKanjiPosition(offset-1, buffer)) {
				buffer[offset] = ' ';
			}
		} else if (scroll >= length) {
			offset = length;
		}
		buffer += offset;
	}
	if (LineNumber_flag == TRUE) {
		move(row, GetMinCol());
		CrtNormal(stdscr);
		if (isunder == TRUE && UnderLine_flag == TRUE) {
			CrtUnderLine(stdscr);
			printw("%5ld:", LineOffset);
		} else {
			printw("%5ld:", LineOffset);
		}
	}

	move(row, GetMinCol()+NumWidth);
	CrtNormal(stdscr);
	if (GetBlockFlg() == ONLINE &&
		min(block_start, block_end) <= LineOffset &&
		LineOffset <= max(block_start, block_end)) {
		CrtReverse(stdscr);
		widthputs(buffer, GetColWidth()-NumWidth);
	} else if (ed->mark == TRUE) {
		CrtReverse(stdscr);
		widthputs(buffer, GetColWidth()-NumWidth);
	} else if (isunder == TRUE && UnderLine_flag == TRUE) {
		CrtUnderLine(stdscr);
		widthputs(buffer, GetColWidth()-NumWidth);
	} else {
		widthputs(buffer, GetColWidth()-NumWidth);
	}
	clrtoeol();
}

VOID
UpLineDraw()
{
	register long Top;
	Top = GetLineOffset() - GetRow();
	if (Top > 0) {
		CrtDrawLine(GetMinRow(), Top, FALSE);
	}
}

VOID
BelowLineDraw()
{
	register long Bottom;

	Bottom = GetLineOffset() + (GetRowWidth() - GetRow());
	if (Bottom <= GetLastNumber()) {
		CrtDrawLine(GetMaxRow(), Bottom, FALSE);
	} else {
		move(GetMaxRow(), GetMinCol());
		clrtoeol();
		CrtNormal(stdscr);
		addch('~');
	}
}

VOID
CrtLineUp()
{
	register long LineOffset;
	LineOffset = GetLineOffset();

	if (LineOffset != GetLastNumber() && (GetBlockFlg() == ONLINE || UnderLine_flag == TRUE)) {
		CrtDrawLine(GetRow()+1, LineOffset+1, FALSE);
		CrtDrawLine(GetRow(), LineOffset, TRUE);
		/*garbagedlines(stdscr, GetRow(), GetRow()+1);*/
	} else if (GetRow() == GetMinRow()) {
		CrtDrawLine(GetRow(), LineOffset, TRUE);
	}
}

VOID
CrtLineDown()
{
	register long LineOffset;
	LineOffset = GetLineOffset();

	if (LineOffset != GetTopNumber()
	    && (GetBlockFlg() == ONLINE || UnderLine_flag == TRUE)
	    && GetRow() != GetMinRow()) {
		CrtDrawLine(GetRow()-1, LineOffset-1, FALSE);
		CrtDrawLine(GetRow(), LineOffset, TRUE);
		if (GetRow() == GetMaxRow()-1) {
			BelowLineDraw();
		}
		/*garbagedlines(stdscr, GetRow()-1, GetRow());*/
	} else if (GetRow() == GetMaxRow()-1) {
		CrtDrawLine(GetRow(), LineOffset, TRUE);
		BelowLineDraw();
	}
}

/*-------------------------------------------------------------------
	Scroll up
-------------------------------------------------------------------*/
VOID
CrtScrollUp()
{
	move(GetMinRow(), GetMinCol());
	deleteln();
}

/*-------------------------------------------------------------------
	Scroll down
-------------------------------------------------------------------*/
VOID
CrtScrollDown()
{
	move(GetMinRow(), GetMinCol());
	insertln();
}

/*-------------------------------------------------------------------
	Draw crt
-------------------------------------------------------------------*/
VOID
CrtDrawAll()
{
	register int MaxRow;
	register int number;
	register long LineNumber;
	register long LastOffset;

	if (stable_standout) {
		clear();
	}
	CrtNormal(stdscr);
	system_guide();
	MaxRow = GetMaxRow();
	LineNumber = GetLineOffset()-(GetRow()-GetMinRow());
	LastOffset = GetLastNumber();
	for (number = GetMinRow(); number <= MaxRow; number++, LineNumber++) {
		if (LineNumber <= LastOffset) {
			CrtDrawLine(number, LineNumber, FALSE);
		} else {
			move(number, GetMinCol());
			clrtoeol();
			CrtNormal(stdscr);
			addch('~');
		}
	}
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
/*	garbagedlines(stdscr, GetMinRow()-1, GetRowWidth());*/
/*	refresh();*/
}

VOID
LineNumberDraw()
{
	register int MaxRow;
	register int number;
	register long LineNumber;
	register long LastOffset;

	if (LineNumber_flag == TRUE) {
		MaxRow = GetMaxRow();
		LineNumber = GetLineOffset()-(GetRow()-GetMinRow());
		LastOffset = GetLastNumber();
		for (number = GetMinRow(); number <= MaxRow; number++, LineNumber++) {
			move(number, GetMinCol());
			CrtNormal(stdscr);
			if (LineNumber <= LastOffset) {
				printw("%5ld:", LineNumber);
			} else {
				clrtoeol();
				addch('~');
			}
		}
	}
}

VOID
toggleLineNumberOp()
{
	toggleLineNumberFlg();
	OffsetSetByColum(GetLineOffset());
	CrtDrawAll();
}

VOID
toggleUnderLineOp()
{
	toggleUnderLineFlg();
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
}

VOID
FreshRedraw()
{
	clear();
	CrtDrawAll();
}

VOID
DeleteAndDraw()
{

	/*BelowLineDraw();*/
	move(GetRow(), GetMinCol());
	deleteln();
	BelowLineDraw();
	LineNumberDraw();
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
}

VOID
InsertAndDraw()
{
	move(GetRow(), GetMinCol());
	insertln();
	LineNumberDraw();
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
}

VOID
putDoubleKey(key)
int key;
{
	move(0, GetMaxCol()-2);
	CrtNormal(stdscr);
	CrtReverse(stdscr);
	printw("^%c", key+'@');
}

VOID
delDoubleKey()
{
	move(0, GetMaxCol()-2);
	CrtNormal(stdscr);
	CrtReverse(stdscr);
	addstr("  ");
}
