/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:ed.h
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <sys/param.h>
#include "machine.h"
#include "5curses.h"
#include "term.h"
#include "kanji.h"

#ifndef	NOUNISTDH
#include <unistd.h>
#endif

#ifndef	NOSTDLIBH
#include <stdlib.h>
#endif

#ifdef	NOUID_T
typedef u_short uid_t;
typedef u_short gid_t;
#endif

#ifdef	NOVOID
#define	VOID
#define	VOID_P	char *
#else
#define	VOID	void
#define	VOID_P	void *
#endif

#ifdef	USEDIRECT
#include <sys/dir.h>
#define	dirent	direct
#else
#include <dirent.h>
#endif

#ifdef	NOFILEMODE
#define	S_IRUSR	00400
#define	S_IWUSR	00200
#define	S_IXUSR	00100
#define	S_IRGRP	00040
#define	S_IWGRP	00020
#define	S_IXGRP	00010
#define	S_IROTH	00004
#define	S_IWOTH	00002
#define	S_IXOTH	00001
#endif

#ifdef	USEGETWD
#define	getcwd(buf, size)	getwd(buf)
#endif

#define	BUFFER_NONE	0
#define	UNDO_SYSTEM	0
#define	SEARCHS_SYSTEM	1
#define	SYSTEM_SYSTEM	2
#define	SHELLS_SYSTEM	3
#define	FOPEN_SYSTEM	4
#define	MACRO_SYSTEM	5
#define	FILE_START	10

#define	ESCAPE	(-1)

#define	JIS	1
#define	EUC	2
#define	SJIS	3

/*Block mode */
#define	OFFLINE	1
#define	ONLINE	2
#define	INLINE	3

#define	DELETE		1
#define	BACKSPACE	2
#define	NONE		3

/*Macro Mode */
#define	MACROSET	1
#define	MACRONONE	2
#define	MACRODO		3

/*Undo Mode */
#define	UNDO_DELETE	1
#define	UNDO_BACKSPACE	2
#define	UNDO_LINE	3

/*Input Mode*/
#define	INSERT 	1
#define	OVERWRITE	2

/*Cursor Mode*/
#define	STOP		1
#define	FREE		2

#define	SAME		1
#define	DIVIDE		2

#define	MAXEDIT 	501+FILE_START
#define	MAXKEYDEF	200
#define	MAXSYSKEYDEF	200
#define	MAXLINESTR	255
#define	MAXEDITLINE	1024
#define	MAXFILEMENU	512


#define	ENGLISH		0
#define	JAPANESE	1

/*Line List*/
struct _ed {
	struct _ed *behind;
	struct _ed *next;
	char *buffer;
	int	mark;
};
typedef struct _ed EditLine;

struct _key {
	short	key1;
	short	key2;
	int	funcNo;
};
typedef struct _key KeyDefine;

extern int lang;
extern int setlang;
extern int NumWidth;
extern int TabStop;
extern int SaveHistoryNumber;
extern int Profile_flag;
extern int BackFile_flag;
extern int InputMode_flag;
extern int LineNumber_flag;
extern int UnderLine_flag;
extern int AutoIndent_flag;
extern int FileChg_flag[];
extern int Fast_flag;
extern int SmoothScroll_flag;
extern int TabMark;
extern int CrMark;
extern int TabCode;
extern int CrCode;
extern int CurrentFileNo;
extern int BackFileNo;
extern int DirectorySort_flag;
extern int CursorMode;
extern int SearchStrCharMode;
extern int Kanji_Code;
extern int Tab_Space_flg;
extern int OnMessage_Flag;
extern int HistorySave_flag;
extern int HistoryRead_flag;
extern char *NxDEFPath;
extern int RollWidth;
extern char EditPathName[][MAXPATHLEN+1];
extern char EditFileName[][MAXNAMLEN+1];
extern int CreateTime[];
extern int FileInode[];
extern int Permission[];
extern char *Shell;
extern int MacroMode;
#define	CNTRL(c)	((c)-'@')
enum {
	_CURSORUP,
	_CURSORDOWN,
	_CURSORLEFT,
	_CURSORRIGHT,
	_SCROLLUP,
	_SCROLLDOWN,
	_ROLLUP,
	_ROLLDOWN,
	_RETURN,
	_BACKSPACE,
	_DELETECHAR,
	_CNTRLINPUT,
	_CURSORLEFTSIDE,
	_CURSORRIGHTSIDE,
	_CURSORUPSIDE,
	_CURSORDOWNSIDE,
	_CURSORTOPSIDE,
	_CURSORENDSIDE,
	_ESCAPE,
	_JMPNEXTTOP,
	_NEXTTOKEN,
	_BEFORETOKEN,
	_DELETETOKEN,
	_NEWLINE,
	_DELETELINE,
	_UNDOLINE,
	_SEARCHBACK,
	_SEARCHFORWARD,
	_SEARCHFORWARDINPUT,
	_SEARCHBACKINPUT,
	_BRACKETSEARCH,
	_TOGGLEFILE,
	_CHANGEFILE,
	_CHANGESTRING,
	_REPEATCHANGEOP,
	_BLOCKSTART,
	_BLOCKYANC,
	_BLOCKONELINEYANC,
	_BLOCKDELETE,
	_BLOCKMOVE,
	_BLOCKPASTE,
	_CURRENTFILESAVE,
	_ALLFILESAVE,
	_ALLFILESAVE_END,
	_FILEOPEN,
	_CURRENTFILEEND,
	_SYSTEMCOMMAND,
	_TAGJMP,
	_SEEOPTIONS,
	_FILEMENU,
	_ALLFILEKILL_END,
	_FRESHSTARTFILE,
	_SHELLESCAPE,
	_TOGGLECURSORMODE,
	_TOGGLELINENUMBER,
	_TOGGLEUNDERLINE,
	_TOGGLEFASTMODE,
	_TOGGLEAUTOINDENT,
	_TOGGLEINPUTMODE,
	_MULTIFILESEARCH,
	_MULTIFILECHANGE,
	_FRESHREDRAW,
	_MARKLINE,
	_DELETETOTOP,
	_DELETETOEND,
	_MACRO,
	_HELP
};

extern KeyDefine	SyStemKey[];
extern KeyDefine	keyDefBuff[];
extern VOID (*funcDefBuff[])();
extern VOID (*helpDefBuff[])();

extern char *HisGets();

#define	max(a, b)	(((a) > (b)) ? (a) : (b))
#define	min(a, b)	(((a) < (b)) ? (a) : (b))
#if 0
#define	iskanji(c)	(((c) & 0x00ff) >= 0x81 && ((c) & 0x00ff) <= 0x9f || ((c) & 0x00ff) >= 0xe0 && ((c) & 0x00ff) <= 0xfc)
#define	iskanji2(c)	(((c) & 0x00ff) >= 0x40 && ((c) & 0x00ff) <= 0x7e || ((c) & 0x00ff) >= 0x80 && ((c) & 0x00ff) <= 0xfc)
#endif

#define	GetMinRow()	(1)
#define	GetMaxRow()	(n_line-1)
#define	GetRowWidth()	(n_line-1)
#define	GetMinCol()	(0)
#define	GetMaxCol()	(n_column-1)
#define	GetColWidth()	(n_column-1)
#define	CrtStandout(w)	putterm(t_standout)
#define	CrtNormal(w)	putterm(t_normal)
#define	CrtReverse(w)	putterm(t_reverse)
#define	CrtUnderLine(w)	putterm(t_underline)
#define	CrtBold(w)	putterm(t_bold)
#define	CrtDim(w)	putterm(t_dim)
#define	CrtBlink(w)	putterm(t_blink)
