/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:hearderr.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>
#include "ed.h"

#if defined (SIGARGINT) || defined (NOVOID)
#define	sigarg_t	int
#else
#define	sigarg_t	void
#endif

#if !defined(SIGIOT) && defined(SIGABRT)
#define	SIGIOT	SIGABRT
#endif

int
HearderrEnd(message)
char *message;
{
	FILE *fp;
	register EditLine *ed;
	int pid, pipefds[2];
	char buffer[16];
	char savedir[MAXPATHLEN+1];
	char *username, *getlogin();
	char *tmpnames;
	struct stat stbuf;
	register int i;
	char filename[MAXPATHLEN+1];
	int	do_Save_flg = FALSE;
	int	file_save_flag = FALSE;

	CrtNormal(stdscr);
	ResetTTY();
	endwin();
	mvprintw(GetMaxRow()-1, GetMinCol(), message);

	for (i = FILE_START; i < MAXEDIT; i++) {
		if (EditPathName[i][0] != '\0') {
			if (FileChg_flag[i] == TRUE) {
				do_Save_flg = TRUE;
				break;
			}
		}
	}
	if (do_Save_flg == FALSE) {
		EndProcedure();
	}
	username = getlogin();
	sprintf(savedir, "%s/neTmp", NxDEFPath);
	if (stat((char *)savedir, &stbuf) < 0) {
		if (mkdir(savedir, 0700) < 0) {
			fprintf(stderr, "Unable to create directory \"%s\"\n", savedir);
			perror("");
			EndProcedure();
		}
	}
	if (chdir(savedir) == -1) {
		EndProcedure();
	}
	BackFile_flag = FALSE;
	for (i = FILE_START; i < MAXEDIT; i++) {
		if (EditPathName[i][0] != '\0') {
			CurrentFileNo = i;
			if (FileChg_flag[CurrentFileNo] == TRUE) {
				sprintf(buffer, "Nx%06dXXXXXX", CurrentFileNo);
				tmpnames = (char *)mktemp(buffer);
				ed = (EditLine *)MakeLine(EditPathName[CurrentFileNo]);
				AppendTop(ed);
				sprintf(filename, "%s/%s", savedir, tmpnames);
				CreateTime[CurrentFileNo] = -1;
				FileInode[CurrentFileNo] = -1;
				filesave(filename);
				chmod(filename, 0600);
				file_save_flag = TRUE;
			}
			ResetFileName(CurrentFileNo);
			FreeLine();
			InitLine();
		}
	}
	if (file_save_flag == TRUE) {

		if (pipe(pipefds) < 0) {
			perror("pipe");
		}

		if ((pid = fork()) < 0) {
			perror("fork");
		}

		if (pid == 0) {
			close(0);
			dup(pipefds[0]);
			close(pipefds[0]);

			close(pipefds[1]);
			execl("/bin/mail", "mail", username, 0);
			perror("exec");
		}

		close(pipefds[0]);

		fp = fdopen(pipefds[1], "w");

		fprintf(fp, "\n\n");
		fprintf(fp, RESTORE_BUFFER_MSG1);
		fprintf(fp, RESTORE_BUFFER_MSG2);
		fprintf(fp, "-----------------------------  by NxEditor. \n");
		fclose(fp);
	}
	EndProcedure();
}

sigarg_t
signalHUP()
{
	HearderrEnd("signal.. (SIGHUP) hangup");
}

sigarg_t
signalILL()
{
	HearderrEnd("sagnal.. (SIGILL)");
}

#ifdef	SIGIOT
sigarg_t
signalIOT()
{
	HearderrEnd("signal.. (SIGIOT)");
}
#endif

#ifdef	SIGEMT
sigarg_t
signalEMT()
{
	HearderrEnd("signal.. (SIGEMT)");
}
#endif

sigarg_t
signalBUS()
{
	HearderrEnd("signal.. (SIGBUS) bus error");
}

sigarg_t
signalSEGV()
{
	HearderrEnd("signal.. (SIGSEGV) segmentation violation");
}

#ifdef	SIGSYS
sigarg_t
signalSYS()
{
	HearderrEnd("signal.. (SIGSYS)");
}
#endif

sigarg_t
signalPIPE()
{
	HearderrEnd("signal.. (SIGPIPE)");
}

sigarg_t
signalTERM()
{
	HearderrEnd("signal.. (SIGTERM) software termination signal");
}

#ifdef	SIGURG
sigarg_t
signalURG()
{
	HearderrEnd("signal.. (SIGURG) urgent condition present on soket");
}
#endif

#ifdef	SIGXCPU
sigarg_t
signalXCPU()
{
	HearderrEnd("signal.. (SIGXCPU) cpu time limit exceeded (see getrlimit(2))");
}
#endif

VOID
SetSignal()
{
	signal(SIGHUP, (sigarg_t (*)())signalHUP);
	signal(SIGILL, (sigarg_t (*)())signalILL);
#ifdef	SIGIOT
	signal(SIGIOT, (sigarg_t (*)())signalIOT);
#endif
#ifdef	SIGEMT
	signal(SIGEMT, (sigarg_t (*)())signalEMT);
#endif
	signal(SIGBUS, (sigarg_t (*)())signalBUS);
	signal(SIGSEGV, (sigarg_t (*)())signalSEGV);
#ifdef	SIGSYS
	signal(SIGSYS, (sigarg_t (*)())signalSYS);
#endif
	signal(SIGPIPE, (sigarg_t (*)())signalPIPE);
	signal(SIGTERM, (sigarg_t (*)())signalTERM);
#ifdef	SIGURG
	signal(SIGURG, (sigarg_t (*)())signalURG);
#endif
#ifdef	SIGXCPU
	signal(SIGXCPU, (sigarg_t (*)())signalXCPU);
#endif
}
