/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:hisgets.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
/*------------------------------------------------------------------------
	Initialize hisGetS Buffer
------------------------------------------------------------------------*/
#include <ctype.h>
#include "ed.h"

extern char *Realloc();

int
InitSyStemBufferArea()
{
	int i;
	register int	tmpFileno;

	tmpFileno = CurrentFileNo;

	for (i = SEARCHS_SYSTEM; i <= MACRO_SYSTEM; i++) {
		CurrentFileNo = i;
		FileStartInit();
	}
	CurrentFileNo = tmpFileno;
}

VOID
HisGetsDrawLine(message, LineOffset)
char *message;
register long LineOffset;
{
	register int length;
	register int scroll;
	register int offset;
	register int StartPos;
	char d_buffer[MAXEDITLINE+1];

	char *buffer;
	register EditLine *ed;

	ed = (EditLine *)GetList(LineOffset);
	length = Tab_Space(ed->buffer, d_buffer);
	StartPos = strlen(message);
	if (ed->next == NULL) {
		d_buffer[length-1] = '\0';
		strcat(d_buffer, " <");
	}
	buffer = d_buffer;
	scroll = GetScroll();
	if (0 < scroll) {
		if (scroll < length) {
			offset = scroll;
			if (IsThisKanjiPosition(offset-1, buffer)) {
				buffer[offset] = ' ';
			}
		} else if (scroll >= length) {
			offset = length;
		}
		buffer += offset;
	}

	CrtNormal(stdscr);
	mvprintw(GetMaxRow(), GetMinCol(), message);
	move(GetMaxRow(), GetMinCol()+StartPos);
	if (ed->next == NULL) {
		widthputs(buffer, GetColWidth()-StartPos-1);
	} else {
		CrtReverse(stdscr);
		widthputs(buffer, GetColWidth()-StartPos-1);
		CrtNormal(stdscr);
	}
}

VOID
HisCursorLeft(message)
char *message;
{
	register int tmp_scroll;

	tmp_scroll = GetScroll();
	ResetCursorPosition();
	if (GetBufferOffset() != 1) {
		BuffsetOffsetLeft();
		CursorLeft();
	}
	if (tmp_scroll != GetScroll()) {
		HisGetsDrawLine(message, GetLineOffset());
	}
}

VOID
HisCursorRight(message)
char *message;
{
	register int tmp_scroll;

	tmp_scroll = GetScroll();
	ResetCursorPosition();
	if (IsKanjiPosition()) {
		BufferOffsetRight();
		CursorRight();
		BufferOffsetRight();
		CursorRight();
	} else {
		BufferOffsetRight();
		CursorRight();
	}
	if (tmp_scroll != GetScroll()) {
		HisGetsDrawLine(message, GetLineOffset());
	}
}

VOID
HisCursorLeftSide(message)
char *message;
{
	register int tmp_scroll;

	tmp_scroll = GetScroll();
	CursorLeftSide();
	if (tmp_scroll != GetScroll()) {
		HisGetsDrawLine(message, GetLineOffset());
	}
}

VOID
HisCursorRightSide(message)
char *message;
{
	register int tmp_scroll;

	tmp_scroll = GetScroll();
	CursorRightSide();
	if (tmp_scroll != GetScroll()) {
		HisGetsDrawLine(message, GetLineOffset());
	}
}

char *
HisGets(dest, message, listID)
char *dest;
char *message;
int listID;
{
	register int key;
	register int tmpListNo;
	register EditLine *ed;
	register long LastOffset;
	register int messagelen;
	register int tmp_LineNumber_flag;
	register int tmp_NumWidth;
	register int ChgFlag;
	char buffer[MAXEDITLINE+1];

	tmpListNo = CurrentFileNo;
	tmp_LineNumber_flag = LineNumber_flag;
	tmp_NumWidth = NumWidth;
	CurrentFileNo = listID;
	LineNumber_flag = TRUE;
	messagelen = (int)strlen(message)-1;
	NumWidth = messagelen + 1;
	strcpy(buffer, "");
	if ((ed = (EditLine *)MakeLine(buffer)) == NULL) {
		WarningCheck(MEMORY_ERR_MSG);
	} else {
		AppendLast(ed);
	}
	LastOffset = GetLastNumber();
	LineOffsetSet(LastOffset);
	ed = (EditLine *)GetList(GetLineOffset());
	SetBufferOffset(0);
	OffsetSetByColum(GetLineOffset());
	ChgFlag = FALSE;
	for (;;) {
		HisGetsDrawLine(message, GetLineOffset());
		move(GetMaxRow(), GetCol()+messagelen);
		key = inkey();
		OffsetSetByColum(GetLineOffset());
		switch(GetSyStemKey(key)) {
		case KEY_UP:
				LineOffsetUp();
				HisCursorLeftSide(message);
				ChgFlag = FALSE;
				break;
		case KEY_DOWN:
				LineOffsetDown();
				HisCursorLeftSide(message);
				ChgFlag = FALSE;
				break;
		case KEY_LEFT:
				HisCursorLeft(message);
				break;
		case KEY_RIGHT:
				ed = (EditLine *)GetList(GetLineOffset());
				if (GetBufferOffset() <= strlen(ed->buffer)) {
					HisCursorRight(message);
				}
				break;
		case KEY_SLEFT:
				HisCursorLeftSide(message);
				break;
		case KEY_SRIGHT:
				HisCursorRightSide(message);
				break;
		case KEY_DC:
				ed = (EditLine *)GetList(GetLineOffset());
				strcpy(buffer, ed->buffer);
				LineOffsetSet(LastOffset);
				ed = (EditLine *)GetList(GetLineOffset());
				if (Realloc(ed, buffer) == NULL) {
					WarningCheck(MEMORY_ERR_MSG);
					CurrentFileNo = tmpListNo;
					LineNumber_flag = tmp_LineNumber_flag;
					NumWidth = tmp_NumWidth;
					BelowLineDraw();
					return NULL;
				}
				if (IsKanjiPosition()) {
					Ledit(INSERT, CursorMode, DELETE);
					Ledit(INSERT, CursorMode, DELETE);
				} else {
					Ledit(INSERT, CursorMode, DELETE);
				}
				strcpy(buffer, ed->buffer);
				ChgFlag = TRUE;
				break;
		case KEY_BACKSPACE:
				ed = (EditLine *)GetList(GetLineOffset());
				strcpy(buffer, ed->buffer);
				LineOffsetSet(LastOffset);
				ed = (EditLine *)GetList(GetLineOffset());
				if (Realloc(ed, buffer) == NULL) {
					WarningCheck(MEMORY_ERR_MSG);
					CurrentFileNo = tmpListNo;
					LineNumber_flag = tmp_LineNumber_flag;
					NumWidth = tmp_NumWidth;
					BelowLineDraw();
					return NULL;
				}
				HisCursorLeft(message);
				OffsetSetByColum(GetLineOffset());
				if (IsKanjiPosition()) {
					Ledit(INSERT, CursorMode, DELETE);
					Ledit(INSERT, CursorMode, DELETE);
				} else {
					Ledit(INSERT, CursorMode, DELETE);
				}
				strcpy(buffer, ed->buffer);
				ChgFlag = TRUE;
				break;
		case KEY_PRINT:
				ed = (EditLine *)GetList(GetLineOffset());
				strcpy(buffer, ed->buffer);
				LineOffsetSet(LastOffset);
				ed = (EditLine *)GetList(GetLineOffset());
				if (Realloc(ed, buffer) == NULL) {
					WarningCheck(MEMORY_ERR_MSG);
					CurrentFileNo = tmpListNo;
					LineNumber_flag = tmp_LineNumber_flag;
					NumWidth = tmp_NumWidth;
					BelowLineDraw();
					return NULL;
				}
				system_msg(CNTRL_INPUT_MSG);
				key = inkey();
				LeditInput(key, InputMode_flag, CursorMode, NONE);
				strcpy(buffer, ed->buffer);
				ChgFlag = TRUE;
				break;
		case KEY_ENTER:
				if (ChgFlag == FALSE && GetLineOffset() != LastOffset) {
					ed = (EditLine *)GetList(GetLineOffset());
					strcpy(buffer, ed->buffer);
					DeleteList(ed);
				}
				LineOffsetSet(LastOffset);
				ed = (EditLine *)GetList(GetLineOffset());
				if (Realloc(ed, buffer) == NULL) {
					WarningCheck(MEMORY_ERR_MSG);
					CurrentFileNo = tmpListNo;
					LineNumber_flag = tmp_LineNumber_flag;
					NumWidth = tmp_NumWidth;
					BelowLineDraw();
					return NULL;
				}
				if (*buffer == '\0') {
					ed = (EditLine *)GetList(GetLineOffset());
					DeleteList(ed);
				}
				CurrentFileNo = tmpListNo;
				LineNumber_flag = tmp_LineNumber_flag;
				NumWidth = tmp_NumWidth;
				BelowLineDraw();
				strcpy(dest, buffer);
				return dest;
		case KEY_CANCEL:
		case CNTRL('['):
				LineOffsetSet(LastOffset);
				ed = (EditLine *)GetList(GetLineOffset());
				if (ChgFlag == TRUE || ed->buffer[0] == '\0') {
					DeleteList(ed);
				}
				CurrentFileNo = tmpListNo;
				LineNumber_flag = tmp_LineNumber_flag;
				NumWidth = tmp_NumWidth;
				BelowLineDraw();
				return NULL;
		default:
				if (!iscntrl(key)) {
					ed = (EditLine *)GetList(GetLineOffset());
					strcpy(buffer, ed->buffer);
					LineOffsetSet(LastOffset);
					ed = (EditLine *)GetList(GetLineOffset());
					if (Realloc(ed, buffer) == NULL) {
						WarningCheck(MEMORY_ERR_MSG);
						CurrentFileNo = tmpListNo;
						LineNumber_flag = tmp_LineNumber_flag;
						NumWidth = tmp_NumWidth;
						BelowLineDraw();
						return NULL;
					}
					Input(key);
					ed = (EditLine *)GetList(GetLineOffset());
					strcpy(buffer, ed->buffer);
					ChgFlag = TRUE;
				}
				break;
		}
	}
}
