/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:input.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include 	"ed.h"

extern char *edlin();
extern char *Realloc();

int
inkey()
{
	int c;

	/* Do MacroMode */
	if (MacroMode == MACRODO) {
		return MacroGetKey();
	}

	/* Normal input */
	refresh();
	c = getkey(0);
	if (MacroMode == MACROSET) {
		addMacro(c);
	}
	return c;
}
/*-------------------------------------------------------------------
	Controled Edit Line
		contrl_flag = BACKSPACE
			or
		contrl_flag = DELETE

-------------------------------------------------------------------*/


VOID
Ledit(input_mode, cursor_mode, contrl_flag)
register int input_mode;
register int cursor_mode;
register int contrl_flag;
{
	int col;
	char buffer[MAXEDITLINE+1];
	register EditLine *ed;

	col = GetBufferOffset();
	ed = (EditLine *)GetList(GetLineOffset());

	strcpy(buffer, ed->buffer);
	edlin(' ', buffer, sizeof(buffer), &col, input_mode, cursor_mode, contrl_flag);
	if (Realloc(ed, buffer) == NULL) {
		WarningCheck(MEMORY_ERR_MSG);
		return;
	}

	SetBufferOffset(col);

	/*FILE Change FLAG*/
	SetFileChangeFlag();
}

VOID
LeditInput(c, input_mode, cursor_mode, contrl_flag)
register int c;
register int input_mode;
register int cursor_mode;
register int contrl_flag;
{
	int col;
	int i;
	char buffer[MAXEDITLINE+1];
	register EditLine *ed;

	col = GetBufferOffset();
	ed = (EditLine *)GetList(GetLineOffset());
	strcpy(buffer, ed->buffer);
	if (c == '\t' && Tab_Space_flg == TRUE) {
		for (i = 0; i < TabStop; i++) {
			edlin(' ', buffer, sizeof(buffer), &col, input_mode, cursor_mode, contrl_flag);
		}
	} else {
		edlin(c, buffer, sizeof(buffer), &col, input_mode, cursor_mode, contrl_flag);
	}
	if (Realloc(ed, buffer) == NULL) {
		WarningCheck(MEMORY_ERR_MSG);
		return;
	}

	SetBufferOffset(col);

	/*FILE Change FLAG*/
	SetFileChangeFlag();
}

VOID
DefaultInput(c, input_mode, cursor_mode, contrl_flag)
register int c;
register int input_mode;
register int cursor_mode;
register int contrl_flag;
{
	LeditInput(c, input_mode, cursor_mode, contrl_flag);
	CursorSetByColOffset();
}

VOID
InputSJIS(key1)
int key1;
{
	int key2;

	if (IsKanji(key1)) {
		key2 = inkey();
		if (IsKanji2(key2)) {
			DefaultInput(key1, InputMode_flag, CursorMode, NONE);
			DefaultInput(key2, InputMode_flag, CursorMode, NONE);
/*
			CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
*/
		} else {
			ungetch2(key2);
		}
	} else {
		DefaultInput(key1, InputMode_flag, CursorMode, NONE);
	}
}

VOID
InputJIS(key1)
{
	int key2;

	if (0xa0a0 <= key1) {
		key2 = key1 & 0x00ff;
		key1 = key1 >> 8;

		DefaultInput(key1, InputMode_flag, CursorMode, NONE);
		OffsetSetByColum(GetLineOffset());
		DefaultInput(key2, InputMode_flag, CursorMode, NONE);
	} else if (0xa0 <= key1) {
		DefaultInput(key1, InputMode_flag, CursorMode, NONE);
		OffsetSetByColum(GetLineOffset());
		key2 = inkey();
		DefaultInput(key2, InputMode_flag, CursorMode, NONE);
	} else {
		DefaultInput(key1, InputMode_flag, CursorMode, NONE);
	}
}

VOID
InputEUC(key1)
int key1;
{
	int key2;

	if (0xa0a0 <= key1) {
		/* It's for Sun_OS's EUC Kanji Code (JEL 1.1)*/

		key2 = key1 & 0x00ff;
		key1 = key1 >> 8;

		DefaultInput(key1, InputMode_flag, CursorMode, NONE);
		DefaultInput(key2, InputMode_flag, CursorMode, NONE);
		garbagedlines(stdscr, GetRow(), 1);
		refresh();
	} else if (0xa0 <= key1) {
		DefaultInput(key1, InputMode_flag, CursorMode, NONE);
		key2 = inkey();
		DefaultInput(key2, InputMode_flag, CursorMode, NONE);
		garbagedlines(stdscr, GetRow(), 1);
		refresh();
	} else {
		DefaultInput(key1, InputMode_flag, CursorMode, NONE);
	}
}

VOID
InputAndCrt(key)
int key;
{
	register int tmp_scroll;

	tmp_scroll = GetScroll();
	if (InputMode_flag == OVERWRITE) {
		if (IsKanjiPosition()) {
			Ledit(INSERT, CursorMode, DELETE);
			Ledit(INSERT, CursorMode, DELETE);
		} else {
			Ledit(INSERT, CursorMode, DELETE);
		}
	}
	switch(Kanji_Code) {
	case EUC:
		InputEUC(key);
		break;
	case SJIS:
		InputSJIS(key);
		break;
	case JIS:
		InputJIS(key);
		break;
	}
	if (tmp_scroll < GetScroll()) {
		CursorSetScroll(GetScroll()+10);
		CursorSetByColOffset();
		CrtDrawAll();
	} else if (tmp_scroll > GetScroll()) {
		CursorSetScroll(GetScroll()-10);
		CursorSetByColOffset();
		CrtDrawAll();
	} else {
		CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
	}
}

VOID
Input(key)
int key;
{
	if (InputMode_flag == OVERWRITE) {
		if (IsKanjiPosition()) {
			Ledit(INSERT, CursorMode, DELETE);
			Ledit(INSERT, CursorMode, DELETE);
		} else {
			Ledit(INSERT, CursorMode, DELETE);
		}
	}
	switch(Kanji_Code) {
	case EUC:
		InputEUC(key);
		break;
	case SJIS:
		InputSJIS(key);
		break;
	case JIS:
		InputJIS(key);
		break;
	}
}
