/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:iskanji.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include "ed.h"


int
IsKanji(c)
int c;
{
	if (Kanji_Code == EUC) {
		if (((c) & 0x00ff) >= 0xa1 && ((c) & 0x00ff) <= 0xfe) {
			return TRUE;
		}
	} else if (Kanji_Code == SJIS) {
		if (((c) & 0x00ff) >= 0x81 && ((c) & 0x00ff) <= 0x9f || ((c) & 0x00ff) >= 0xe0 && ((c) & 0x00ff) <= 0xfc) {
		return TRUE;
		}
	} else if (Kanji_Code == JIS) {
		if (((c) & 0x00ff) >= 0xa0 && ((c) & 0x00ff) <= 0xff) {
			return TRUE;
		}
	}
	return FALSE;
}

int
IsKanji2(c)
int c;
{
	if (Kanji_Code == EUC) {
		if (((c) & 0x00ff) >= 0x00a1 && ((c) & 0x00ff) <= 0x00fe) {
			return TRUE;
		}
	} else if (Kanji_Code == SJIS) {
		if (((c) & 0x00ff) >= 0x40 && ((c) & 0x00ff) <= 0x7e || ((c) & 0x00ff) >= 0x80 && ((c) & 0x00ff) <= 0xfc) {
			return TRUE;
		}
	} else if (Kanji_Code == JIS) {
		if (((c) & 0x00ff) >= 0x00a0 && ((c) & 0x00ff) <= 0x00ff) {
			return TRUE;
		}
	}
	return FALSE;
}

#define	KT_KIGOU	001
#define	KT_ALNUM	002
#define	KT_HIRA		004
#define	KT_KATA		010
#define	KT_OTHER	020

int
GetKanjiType(c1, c2)
int c1, c2;
{
	int c;

	c = (((c1) & 0x00ff) << 8) | ((c2) & 0x00ff);
	if (Kanji_Code == EUC) {
		if (c == 0xa1ab || c == 0xa1ac || c == 0xa1bc) {
			return KT_HIRA | KT_KATA;
		} else if (c >= 0xa1a1 && c <= 0xa3af) {
			return KT_KIGOU;
		} else if (c >= 0xa3b0 && c <= 0xa3fa) {
			return KT_ALNUM;
		} else if (c >= 0xa4a1 && c <= 0xa4f3) {
			return KT_HIRA;
		} else if (c >= 0xa5a1 && c <= 0xa5f6) {
			return KT_KATA;
		}
	} else if (Kanji_Code == SJIS) {
		if (c == 0x814a || c == 0x814b || c == 0x815b) {
			return KT_HIRA | KT_KATA;
		} else if (c >= 0x8140 && c <= 0x824e) {
			return KT_KIGOU;
		} else if (c >= 0x824f && c <= 0x829a) {
			return KT_ALNUM;
		} else if (c >= 0x829f && c <= 0x82f1) {
			return KT_HIRA;
		} else if (c >= 0x8340 && c <= 0x8396) {
			return KT_KATA;
		}
	} else if (Kanji_Code == JIS) {
		if (c == 0x212b || c == 0x212c || c == 0x213c) {
			return KT_HIRA | KT_KATA;
		} else if (c >= 0x2121 && c <= 0x232f) {
			return KT_KIGOU;
		} else if (c >= 0x2330 && c <= 0x237a) {
			return KT_ALNUM;
		} else if (c >= 0x2421 && c <= 0x2473) {
			return KT_HIRA;
		} else if (c >= 0x2521 && c <= 0x2576) {
			return KT_KATA;
		}
	}
	return KT_OTHER;
}
