/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:jmp.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include <ctype.h>
#include "ed.h"

VOID
CursorLeftSide()
{
	SetBufferOffset(1);
}

VOID
CursorRightSide()
{
	register int length;
	register EditLine *ed;

	ed = (EditLine *)GetList(GetLineOffset());
	length = strlen(ed->buffer)+1;
	SetBufferOffset(length);
}

VOID
CursorUpSide()
{
	LineOffsetSet(GetLineOffset()-GetRow()+1);
	CursorSetRow(GetMinRow());
}

VOID
CursorDownSide()
{
	register long LastOffset;
	register long LineOffset;

	LastOffset = GetLastNumber();
	LineOffset = GetLineOffset();
	if (LastOffset <= LineOffset + (long)(GetRowWidth() - GetRow())-1) {
		LineOffsetSet(LastOffset);
		CursorSetRow(GetRow()+(LastOffset-LineOffset));
	} else {
		LineOffsetSet(LineOffset + (long)(GetRowWidth()-GetRow())-1);
		CursorSetRow(GetMaxRow()-1);
	}
}

VOID
CursorTopSide()
{
	LineOffsetSet(GetTopNumber());
	CursorSetRow(GetMinRow());
}

VOID
CursorEndSide()
{
	register long LastOffset;

	LastOffset = GetLastNumber();
	if ((long)GetMaxRow() < LastOffset) {
		CursorSetRow(GetMaxRow()-1);
	} else {
		CursorSetRow((int)LastOffset);
	}

	LineOffsetSet(LastOffset);
}

VOID
NextToken()
{
	register int i;
	register int tmp_scroll;
	register long LastOffset;
	register EditLine *ed;
	register int strlength;
	int tmp, type;

	LastOffset = GetLastNumber();
	ed = (EditLine *)GetList(GetLineOffset());
	strlength = strlen(ed->buffer);
	ResetCursorPosition();
	i = GetBufferOffset()-1;
	tmp_scroll = GetScroll();
	if (i >= strlength) {
	if (GetLineOffset() < LastOffset) {
			CursorDown();
			LineOffsetDown();
			CrtLineDown();
			SetBufferOffset(1);
			if (tmp_scroll != GetScroll()) {
				CrtDrawAll();
			}
		}
		return;
	}
	if (IsKanjiPosition()) {
		type = GetKanjiType(ed->buffer[i], ed->buffer[i+1]);
		do {
			tmp = type;
			CursorRightOp();
			i = GetBufferOffset()-1;
			if (i >= strlength) {
				break;
			}
			type = GetKanjiType(ed->buffer[i], ed->buffer[i+1]);
		} while (IsKanjiPosition() && (type & tmp));
		i = GetBufferOffset()-1;
	} else if (isalnum(ed->buffer[i])) {
		while (isalnum(ed->buffer[i])) {
			i++;
			if (i >= strlength) {
				break;
			}
		}
	} else if (ispunct(ed->buffer[i])) {
		while (ispunct(ed->buffer[i])) {
			i++;
			if (i >= strlength) {
				break;
			}
		}
	}
	while (ed->buffer[i] == ' '
	|| iscntrl((unsigned char)(ed->buffer[i]))) {
		i++;
		if (i >= strlength) {
			break;
		}
	}
	SetBufferOffset(i+1);
	if (tmp_scroll != GetScroll()) {
		CrtDrawAll();
	}
}

VOID
BeforeToken()
{
	register int i;
	register int tmp_scroll;
	register EditLine *ed;
	register int strlength;
	int tmp, type;

	ed = (EditLine *)GetList(GetLineOffset());
	strlength = strlen(ed->buffer);
	ResetCursorPosition();
	ResetKanjiPosition();
	i = GetBufferOffset()-1;
	tmp_scroll = GetScroll();
	if (i <= 0) {
		if (GetLineOffset() > 1) {
			LineOffsetUp();
			CursorUp();
			CrtLineUp();
			ed = (EditLine *)GetList(GetLineOffset());
			SetBufferOffset(strlen(ed->buffer)+1);
			if (tmp_scroll != GetScroll()) {
				CrtDrawAll();
			}
		}
		return;
	} else if (i > strlength) {
			SetBufferOffset(strlength);
			if (tmp_scroll != GetScroll()) {
				CrtDrawAll();
			}
			return;
	}
	while (ed->buffer[i-1] == ' '
	|| iscntrl((unsigned char)(ed->buffer[i-1]))) {
		i--;
		if (i <= 0) {
			SetBufferOffset(i);
			if (tmp_scroll != GetScroll()) {
				CrtDrawAll();
			}
			return;
		}
	}
	SetBufferOffset(i+1);
	if (IsThisKanjiPosition(i-2, ed->buffer)) {
		type = GetKanjiType(ed->buffer[i-2], ed->buffer[i-1]);
		do {
			tmp = type;
			CursorLeftOp();
			ResetKanjiPosition();
			i = GetBufferOffset()-1;
			if (i <= 0) {
				SetBufferOffset(i);
				if (tmp_scroll != GetScroll()) {
					CrtDrawAll();
				}
				return;
			}
			type = GetKanjiType(ed->buffer[i-2], ed->buffer[i-1]);
		} while (IsThisKanjiPosition(i-2, ed->buffer) && (type & tmp));
		i = GetBufferOffset();
	} else if (isalnum(ed->buffer[i-1])) {
		while (isalnum(ed->buffer[i-1])) {
			i--;
			if (i <= 0) {
				i--;
				break;
			}
		}
	} else if (ispunct(ed->buffer[i-1])) {
		while (ispunct(ed->buffer[i-1])) {
			i--;
			if (i <= 0) {
				i--;
				break;
			}
		}
	} else if (ed->buffer[i-1] == ' '
	|| iscntrl((unsigned char)(ed->buffer[i-1]))) {
		while (ed->buffer[i-1] == ' ' ||
		iscntrl((unsigned char)(ed->buffer[i-1]))) {
			i--;
			if (i <= 0) {
				i--;
				break;
			}
		}
	}
	SetBufferOffset(i+1);
	if (tmp_scroll != GetScroll()) {
		CrtDrawAll();
	}
}

VOID
JmpStringTop()
{
	register int i;
	register EditLine *ed;
	register int strlength;


	ed = (EditLine *)GetList(GetLineOffset());
	strlength = strlen(ed->buffer);

	for (i = 0; i < strlength; i++) {
		if (ed->buffer[i] != '\t' && ed->buffer[i] != ' ') {
			break;
		}
	}
	SetBufferOffset(i+1);
	if (GetRow() < GetMaxRow()-1) {
		CursorSetRow(GetRow()+1);
	} else {
		CrtScrollUp();
		BelowLineDraw();
	}
}

VOID
JmpNumber(jmpoffset)
long jmpoffset;
{
	register int ColOffset;
	register long LineOffset;
	register long LastOffset;

	ColOffset = GetBufferOffset();
	LineOffset = jmpoffset;
	LastOffset = GetLastNumber();

	if (LineOffset != GetLineOffset()) {
		if (LineOffset < GetLineOffset()) {
		/* target before current line */
			while (GetLineOffset() > LineOffset
				&& GetLineOffset() > GetTopNumber()) {
				if (GetRow() > GetMinRow()) {
					CursorSetRow(GetRow()-1);
				}
				LineOffsetUp();
			}
		} else {
		/* target after current line */
			while (GetLineOffset() < LineOffset
				&& GetLineOffset() < LastOffset) {
				if (GetRow() < GetMaxRow()-1) {
					CursorSetRow(GetRow()+1);
				}
				LineOffsetDown();
			}
		}
	}
	LineOffsetSet(LineOffset);
	SetBufferOffset(ColOffset);
	CursorSetByColOffset();
}

VOID
JmpNumberStr(jmpstr)
char *jmpstr;
{
	JmpNumber(atol(jmpstr));
}

/*-------------------------------------------------------------------
	Cursor next top
-------------------------------------------------------------------*/
VOID
CursorJmpNextTopOp()
{
	register int tmp_scroll;
	/*register long Bottom;*/
	register long LineOffset;

	tmp_scroll = GetScroll();

	ResetCursorPosition();
	LineOffset = GetLineOffset();
	/*Bottom = LineOffset + (GetRowWidth() - GetRow())+1;*/
	if (GetLineOffset() < GetLastNumber()) {

		CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
		LineOffsetDown();
		JmpStringTop();
		/*CrtDrawLine(GetMaxRow(), Bottom, FALSE);*/
		CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
	}
	if (tmp_scroll != GetScroll()) {
		CrtDrawAll();
	}
}
