/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:l_offset.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include "ed.h"

static long LineOffset[MAXEDIT];

VOID
LineOffsetInit()
{
	LineOffset[CurrentFileNo] = GetTopNumber();
}

long
GetLineOffset()
{
	return LineOffset[CurrentFileNo];
}

VOID
LineOffsetUp()
{
	if (LineOffset[CurrentFileNo] > GetTopNumber()) {
		LineOffset[CurrentFileNo]--;
		SetBlockEnd();
	}
}

VOID
LineOffsetDown()
{
	if (LineOffset[CurrentFileNo] < GetLastNumber()) {
		LineOffset[CurrentFileNo]++;
		SetBlockEnd();
	}
}

VOID
ScrollUpOp()
{
	register int i;
	register long Offset;
	Offset = GetLineOffset();
	for (i = 0; i < GetRowWidth(); i++) {
		LineOffsetDown();
	}
	if (Offset != GetLineOffset()) {
		SetBlockEnd();
		CrtDrawAll();
	}
}

VOID
ScrollDownOp()
{
	register int i;
	register long Offset;

	Offset = GetLineOffset();
	for (i = 0; i < GetRowWidth() && GetRow() < GetLineOffset(); i++) {
		LineOffsetUp();
	}
	if (Offset != GetLineOffset()) {
		SetBlockEnd();
		CrtDrawAll();
	}
}

VOID
LineOffsetSet(offset)
register long offset;
{
	register long LastOffset;
	LastOffset = GetLastNumber();
	if (GetTopNumber() <= offset && offset < LastOffset) {
		LineOffset[CurrentFileNo] = offset;
	} else if (GetTopNumber() > offset) {
		LineOffset[CurrentFileNo] = GetTopNumber();
	} else if (LastOffset <= offset) {
		LineOffset[CurrentFileNo] = LastOffset;
	}
	SetBlockEnd();
}
