/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:line.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include <ctype.h>
#include "ed.h"

extern char *Realloc();

VOID
AutoIndent()
{
	register int i;
	register EditLine *ed;
	char tmpbuf[MAXEDITLINE+1];

	if (AutoIndent_flag == TRUE && GetTopNumber() < GetLineOffset()) {
		ed = (EditLine *)GetList(GetLineOffset()-1);
		for (i = 0; i < strlen(ed->buffer); i++) {
			if (ed->buffer[i] != '\t' && ed->buffer[i] != ' ') {
				break;
			} else {
				tmpbuf[i] = ed->buffer[i];
			}
		}
		tmpbuf[i] = '\0';
		ed = (EditLine *)GetList(GetLineOffset());
		strcat(tmpbuf, ed->buffer);
		if (Realloc(ed, tmpbuf) == NULL) {
			WarningCheck(MEMORY_ERR_MSG);
			return;
		}
		/*FILE Change FLAG*/
		SetFileChangeFlag();
	}
}

/*-------------------------------------------------------------------
	Delete
-------------------------------------------------------------------*/
VOID
DeleteOp()
{
	register EditLine *ed;
	register int length;
	register int scroll;
	int delchar;

	flushinp();
	scroll = GetScroll();
	ed = (EditLine *)GetList(GetLineOffset());
	length = strlen(ed->buffer);
	ResetCursorPosition();
	ResetKanjiPosition();
	if (length < GetBufferOffset()) {
		LeditInput(CNTRL(' '), INSERT, CursorMode, NONE);
		Ledit(INSERT, CursorMode, BACKSPACE);
		BelowLineDraw();
		CatLine();
		DeleteAndDraw();
		if (scroll != GetScroll()) {
			CrtDrawAll();
		}
	} else {
		if (IsKanjiPosition()) {
			UndoMode(UNDO_DELETE);
			delchar = ed->buffer[GetBufferOffset()-1];
			AddCharToUndoBuffer(delchar);
			Ledit(INSERT, CursorMode, DELETE);
			delchar = ed->buffer[GetBufferOffset()-1];
			AddCharToUndoBuffer(delchar);
			Ledit(INSERT, CursorMode, DELETE);
		} else {
			UndoMode(UNDO_DELETE);
			delchar = ed->buffer[GetBufferOffset()-1];
			AddCharToUndoBuffer(delchar);
			Ledit(INSERT, CursorMode, DELETE);
		}
	}
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
}

/*-------------------------------------------------------------------
	Back space
-------------------------------------------------------------------*/
VOID
BackSpaceOp()
{
	register EditLine *ed;
	register long LineOffset;
	register int scroll;
	int delchar;
	int delchar1;
	int delchar2;

	flushinp();
	scroll = GetScroll();
	LineOffset = GetLineOffset();
	ed = (EditLine *)GetList(LineOffset);
	ResetCursorPosition();
	if (GetBufferOffset() == 1 && LineOffset != 1) {
		BelowLineDraw();
		LineOffsetSet(LineOffset-1);
		ed = ed->behind;
		SetBufferOffset(strlen(ed->buffer)+1);
		CursorSetRow(GetRow()-1);
		CatLine();
		DeleteAndDraw();
		if (scroll != GetScroll()) {
			CrtDrawAll();
		}
	} else if (GetBufferOffset() != 1) {
		CursorLeftOp();
		ResetKanjiPosition();
		if (IsKanjiPosition()) {
			UndoMode(UNDO_BACKSPACE);
			delchar1 = ed->buffer[GetBufferOffset()-1];
			Ledit(INSERT, CursorMode, DELETE);
			delchar2 = ed->buffer[GetBufferOffset()-1];
			AddCharToUndoBuffer(delchar2);
			Ledit(INSERT, CursorMode, DELETE);
			AddCharToUndoBuffer(delchar1);
		} else {
			UndoMode(UNDO_BACKSPACE);
			delchar = ed->buffer[GetBufferOffset()-1];
			AddCharToUndoBuffer(delchar);
			Ledit(INSERT, CursorMode, DELETE);
		}
	}
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
}

VOID
DeleteToken()
{
	register int i;
	register EditLine *ed;
	char buffer[MAXEDITLINE+1];
	int tmp, type;

	ed = (EditLine *)GetList(GetLineOffset());
	strcpy(buffer, ed->buffer);
	i = GetBufferOffset()-1;

	if (buffer[i] == ' ') {
		UndoMode(UNDO_DELETE);
		while (buffer[i] == ' ') {
			AddCharToUndoBuffer(buffer[i]);
			Ledit(INSERT, CursorMode, DELETE);
			i++;
		}
	} else if (IsKanjiPosition()) {
		UndoMode(UNDO_DELETE);
		type = GetKanjiType(buffer[i], buffer[i+1]);
		do {
			tmp = type;
			AddCharToUndoBuffer(buffer[i++]);
			Ledit(INSERT, CursorMode, DELETE);
			AddCharToUndoBuffer(buffer[i++]);
			Ledit(INSERT, CursorMode, DELETE);
			type = GetKanjiType(buffer[i], buffer[i+1]);
		} while (IsKanjiPosition() && (type & tmp));
	} else if (buffer[i] == '\t') {
		UndoMode(UNDO_DELETE);
		AddCharToUndoBuffer(buffer[i]);
		Ledit(INSERT, CursorMode, DELETE);
	} else if (isalnum(buffer[i])) {
		UndoMode(UNDO_DELETE);
		while (isalnum(buffer[i])) {
			AddCharToUndoBuffer(buffer[i]);
			Ledit(INSERT, CursorMode, DELETE);
			i++;
		}
	} else if (ispunct(buffer[i])) {
		UndoMode(UNDO_DELETE);
		while (ispunct(buffer[i])) {
			AddCharToUndoBuffer(buffer[i]);
			Ledit(INSERT, CursorMode, DELETE);
			i++;
		}
	} else if (iscntrl((unsigned char)(buffer[i]))) {
		UndoMode(UNDO_DELETE);
		while (iscntrl((unsigned char)(buffer[i]))) {
			AddCharToUndoBuffer(buffer[i]);
			Ledit(INSERT, CursorMode, DELETE);
			i++;
		}
	}
	/*FILE Change FLAG*/
	SetFileChangeFlag();
}

int
SplitLine()
{
	register int i;
	char buffer[MAXEDITLINE+1];
	char tmp_buff[MAXEDITLINE+1];
	register EditLine *ed;

	ResetCursorPosition();
	LeditInput(CNTRL(' '), INSERT, CursorMode, NONE);
	Ledit(INSERT, CursorMode, BACKSPACE);
	ed = (EditLine *)GetList(GetLineOffset());
	i = GetBufferOffset();
	strcpy(buffer, ed->buffer);
	while (buffer[i-1] != '\0') {
		tmp_buff[i-GetBufferOffset()] = buffer[i-1];
		i++;
	}
	buffer[GetBufferOffset()-1] = '\0';
	if (Realloc(ed, buffer) == NULL) {
		WarningCheck(MEMORY_ERR_MSG);
		return FALSE;
	}

	tmp_buff[i-GetBufferOffset()] = '\0';
	if ((ed = (EditLine *)MakeLine(tmp_buff)) == NULL) {
		WarningCheck(MEMORY_ERR_MSG);
		return FALSE;
	} else {
		InsertLine(GetList(GetLineOffset()), ed);
		/*FILE Change FLAG*/
		SetFileChangeFlag();
	}
	return TRUE;
}

VOID
NewLineOp()
{
	register EditLine *ed;
	char tmp_buff[MAXEDITLINE+1];

	tmp_buff[0] = '\0';
	CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
	if ((ed = (EditLine *)MakeLine(tmp_buff)) == NULL) {
		WarningCheck(MEMORY_ERR_MSG);
	} else {
		InsertLine(GetList(GetLineOffset()-1), ed);
		/*FILE Change FLAG*/
		SetFileChangeFlag();
	}
	InsertAndDraw();
}

int
CatLine()
{
	char tmpbuff1[MAXEDITLINE+1];
	char tmpbuff2[MAXEDITLINE+1];
	register EditLine *ed;

	if (GetLineOffset() < GetLastNumber()) {
		ed = (EditLine *)GetList(GetLineOffset());
		strcpy(tmpbuff1, ed->buffer);
		/*ed = (EditLine *)GetList(GetLineOffset()+1);*/
		ed = ed->next;
		strcpy(tmpbuff2, ed->buffer);
		if (strlen(tmpbuff1)+strlen(tmpbuff2) > MAXEDITLINE) {
			WarningCheck(LINE_BUFFER_OVER_MSG);
			return FALSE;
		}
		/*ed = (EditLine *)GetList(GetLineOffset()+1);*/
		DeleteList(ed);

		strcat(tmpbuff1, tmpbuff2);

		ed = (EditLine *)GetList(GetLineOffset());
		if (Realloc(ed, tmpbuff1) == NULL) {
			WarningCheck(MEMORY_ERR_MSG);
			return FALSE;
		}
		/*FILE Change FLAG*/
		SetFileChangeFlag();

		return TRUE;
	}
	return FALSE;
}

VOID
DeleteLineOp()
{
	register EditLine *ed;
	char paste[MAXEDITLINE+1];


	flushinp();
	BelowLineDraw();
	if (GetLineOffset() < GetLastNumber()) {
		ed = (EditLine *)GetList(GetLineOffset());
		strcpy(paste, ed->buffer);
		DeleteList(ed);
		SetFileChangeFlag();
		UndoMode(UNDO_LINE);
		AddStrToUndoBuffer(paste);
	} else {
		ed = (EditLine *)GetList(GetLineOffset());
		strcpy(paste, ed->buffer);
		UndoMode(UNDO_LINE);
		AddStrToUndoBuffer(paste);
		if (Realloc(ed, "") == NULL) {
			WarningCheck(MEMORY_ERR_MSG);
			return;
		}
		SetFileChangeFlag();
	}
	DeleteAndDraw();
}

VOID
UndoLineOp()
{
	DoUndo();
}

/*-------------------------------------------------------------------
	Cursor next token
-------------------------------------------------------------------*/
VOID
DeleteTokenOp()
{
	register EditLine *ed;
	register int length;

	flushinp();

	ed = (EditLine *)GetList(GetLineOffset());
	length = strlen(ed->buffer);
	ResetCursorPosition();
	ResetKanjiPosition();
	if (length < GetBufferOffset()) {
		LeditInput(CNTRL(' '), INSERT, CursorMode, NONE);
		Ledit(INSERT, CursorMode, BACKSPACE);
		BelowLineDraw();
		CatLine();
		DeleteAndDraw();
	} else {
		DeleteToken();
		CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
	}
}

/*-------------------------------------------------------------------
	Split line
-------------------------------------------------------------------*/
VOID
SplitLineOp()
{
	register int scroll;
	scroll = GetScroll();
	SplitLine();
	CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
	LineOffsetDown();
	AutoIndent();
	JmpStringTop();
	InsertAndDraw();
	if (scroll != GetScroll()) {
		CrtDrawAll();
	}
}

VOID
DeleteToTop()
{
	register int i;
	register EditLine *ed;
	register int offset;
	int delchar;
	int delchar1;
	int delchar2;

	ed = (EditLine *)GetList(GetLineOffset());
	UndoMode(UNDO_BACKSPACE);
	ResetCursorPosition();
	offset = GetBufferOffset()-1;
	for (i = 0; i < offset; i++) {
		CursorLeftOp();
		ResetKanjiPosition();
		if (IsKanjiPosition()) {
			delchar1 = ed->buffer[GetBufferOffset()-1];
			Ledit(INSERT, CursorMode, DELETE);
			delchar2 = ed->buffer[GetBufferOffset()-1];
			AddCharToUndoBuffer(delchar2);
			Ledit(INSERT, CursorMode, DELETE);
			AddCharToUndoBuffer(delchar1);
			i++;
		} else {
			delchar = ed->buffer[GetBufferOffset()-1];
			AddCharToUndoBuffer(delchar);
			Ledit(INSERT, CursorMode, DELETE);
		}
	}
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
	CursorSetCol(GetMinCol());
}

VOID
DeleteToEnd()
{
	register int i;
	register EditLine *ed;
	register int strlength;
	int delchar;

	ed = (EditLine *)GetList(GetLineOffset());
	strlength = strlen(ed->buffer);
	UndoMode(UNDO_DELETE);
	ResetCursorPosition();
	for (i = GetBufferOffset()-1; i < strlength; i++) {
		if (IsKanjiPosition()) {
			delchar = ed->buffer[GetBufferOffset()-1];
			AddCharToUndoBuffer(delchar);
			Ledit(INSERT, CursorMode, DELETE);
			delchar = ed->buffer[GetBufferOffset()-1];
			AddCharToUndoBuffer(delchar);
			Ledit(INSERT, CursorMode, DELETE);
			i++;
		} else {
			delchar = ed->buffer[GetBufferOffset()-1];
			AddCharToUndoBuffer(delchar);
			Ledit(INSERT, CursorMode, DELETE);
		}
	}
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
}

/*-------------------------------------------------------------------
	Control Character Input
-------------------------------------------------------------------*/
VOID
CntrlInputOp()
{
	register int c;
	system_msg(CNTRL_INPUT_MSG);
	c = inkey();
	DefaultInput(c, InputMode_flag, CursorMode, NONE);
	garbagedlines(stdscr, GetRow(), 1);
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
}
