/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:ls.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include <sys/types.h>
#include <sys/stat.h>
#include "ed.h"

static char backpath[MAXPATHLEN+1];

static int
compare1(str1, str2)
char *str1;
char *str2;
{
	return strcmp(str1, str2);
}

char *
LsMenu(filename, path)
char *filename;
char *path;
{
	register int num;
	DIR *dirp;
	struct dirent *dir;
	struct stat sbuf;
	char tmppath[MAXPATHLEN+1];
	char tmpbuff[MAXFILEMENU][MAXNAMLEN+1];
	char *buffer[MAXFILEMENU];
	char pathname[MAXPATHLEN+1];
	register int m_select;
	int compare1();

	getcwd(tmppath, MAXPATHLEN);
	if (*path == '\0') {
		chdir(backpath);
	} else {
		chdir(path);
		strcpy(backpath, path);
	}
	do {
		m_select = 0;
		getcwd(pathname, MAXPATHLEN);
		move(0, 0);
		clrtoeol();
		CrtNormal(stdscr);
		CrtReverse(stdscr);
		printw("Path : ");
		widthputs(pathname, GetMaxCol()-7);
		if ((dirp = opendir(".")) == NULL) {
			WarningCheck(CAN_NOT_OPEN_DIR_MSG);
			chdir(tmppath);
			*filename = '\0';
			return filename;
		}

		num = 0;
		while (num < MAXFILEMENU && (dir = readdir(dirp)) != NULL) {
			strcpy(tmpbuff[num], dir->d_name);
			if (strcmp(tmpbuff[num], ".") == 0
			|| (strcmp(pathname, "/") == 0
			&& strcmp(tmpbuff[num], "..") == 0)) continue;
			buffer[num] = tmpbuff[num];
			stat(dir->d_name, &sbuf);
			if ((sbuf.st_mode & S_IFMT) == S_IFDIR) {
				strcat(tmpbuff[num], "/");
			}
			num++;
		}
		closedir(dirp);
		if (DirectorySort_flag == TRUE) {
			qsort(tmpbuff, num, MAXNAMLEN+1, compare1);
		}
		NumMenu_open(GetMinRow(), GetMinCol(), buffer, num);
		m_select = NumMenu_select(GetMinRow(), GetMinCol(), buffer, num, m_select);
		if (m_select == -1) {
			chdir(tmppath);
			*filename = '\0';
			return filename;
		}
		stat(tmpbuff[m_select], &sbuf);
		if ((sbuf.st_mode & S_IFMT) == S_IFDIR) {
			strcpy(pathname, tmpbuff[m_select]);
			chdir(pathname);
			getcwd(backpath, MAXPATHLEN);
		}
	} while ((sbuf.st_mode & S_IFMT) == S_IFDIR);

	getcwd(filename, MAXPATHLEN);
	strcat(filename, "/");
	strcat(filename, tmpbuff[m_select]);
	getcwd(backpath, MAXPATHLEN);
	chdir(tmppath);

	return filename;
}
