/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:macros.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include "ed.h"

extern char *Realloc();
static long MacroBufferOffset;
static long MacroOffset;
static int CurrentKey;
/*
 *	Search Only
 */
long
SearchMacroKey(key1, key2)
int key1;
int key2;
{
	register EditLine *ed;
	register long i;
	register int tmpListNo;
	register int tmp_LineNumber_flag;
	register int tmp_NumWidth;

	tmpListNo = CurrentFileNo;
	tmp_LineNumber_flag = LineNumber_flag;
	tmp_NumWidth = NumWidth;

	CurrentFileNo = MACRO_SYSTEM;

	for (i = GetTopNumber(); i <= GetLastNumber(); i++) {
		ed = (EditLine *)GetList(i);
		if (ed->buffer[0] == key1 && ed->buffer[1] == key2) {
			CurrentFileNo = tmpListNo;
			LineNumber_flag = tmp_LineNumber_flag;
			NumWidth = tmp_NumWidth;
			return i;
		}
	}
	CurrentFileNo = tmpListNo;
	LineNumber_flag = tmp_LineNumber_flag;
	NumWidth = tmp_NumWidth;
	return -1;
}

/*
 *	Set Macro Key
 */
int
SetMacroKey(key1, key2)
int key1;
int key2;
{
	register EditLine *ed;
	register int flag;
	register int tmpListNo;
	register int tmp_LineNumber_flag;
	register int tmp_NumWidth;
	register long offset;

	tmpListNo = CurrentFileNo;
	tmp_LineNumber_flag = LineNumber_flag;
	tmp_NumWidth = NumWidth;
	CurrentFileNo = MACRO_SYSTEM;
	flag = FALSE;
	if ((offset = SearchMacroKey(key1, key2)) != -1) {
		ed = (EditLine *)GetList(offset);
		DeleteList(ed);
	}
	ed = (EditLine *)GetList(MacroBufferOffset);
	ed->buffer[0] = key1;
	ed->buffer[1] = key2;
	flag = TRUE;

	CurrentFileNo = tmpListNo;
	LineNumber_flag = tmp_LineNumber_flag;
	NumWidth = tmp_NumWidth;
	MacroMode = MACRONONE;
	system_msg("Set Macro");
	return flag;
}

VOID
addMacro(c)
int c;
{
	register EditLine *ed;
	register int tmpListNo;
	register int tmp_LineNumber_flag;
	register int tmp_NumWidth;
	register int strlength;
	char buffer[MAXEDITLINE+1];

	tmpListNo = CurrentFileNo;
	tmp_LineNumber_flag = LineNumber_flag;
	tmp_NumWidth = NumWidth;

	CurrentFileNo = MACRO_SYSTEM;

	LineOffsetSet(MacroBufferOffset);
	ed = (EditLine *)GetList(GetLineOffset());
	strcpy(buffer, ed->buffer);
	strlength = strlen(buffer);
	buffer[strlength] = c;
	buffer[strlength+1] = '\0';
	if (Realloc(ed, buffer) == NULL) {
		WarningCheck(MEMORY_ERR_MSG);
	}

	CurrentFileNo = tmpListNo;
	LineNumber_flag = tmp_LineNumber_flag;
	NumWidth = tmp_NumWidth;
}

/*
 *	Search and Do Macro
 */
int
SearchAndDoMacro(key1, key2)
int key1;
int key2;
{
	register int flag;
	register long Offset;
	register int tmpListNo;
	register int tmp_LineNumber_flag;
	register int tmp_NumWidth;

	tmpListNo = CurrentFileNo;
	tmp_LineNumber_flag = LineNumber_flag;
	tmp_NumWidth = NumWidth;

	CurrentFileNo = MACRO_SYSTEM;
	Offset = SearchMacroKey(key1, key2);
	flag = FALSE;
	if (Offset != -1) {
		MacroMode = MACRODO;
		MacroOffset = Offset;
		CurrentKey = 2;
		flag = TRUE;
	}
	CurrentFileNo = tmpListNo;
	LineNumber_flag = tmp_LineNumber_flag;
	NumWidth = tmp_NumWidth;
	return flag;
}

int
MacroGetKey()
{
	register EditLine *ed;
	register int key;
	register int tmpListNo;
	register int tmp_LineNumber_flag;
	register int tmp_NumWidth;

	tmpListNo = CurrentFileNo;
	tmp_LineNumber_flag = LineNumber_flag;
	tmp_NumWidth = NumWidth;

	CurrentFileNo = MACRO_SYSTEM;

	ed = (EditLine *)GetList(MacroOffset);
	key = ed->buffer[CurrentKey];

	CurrentKey++;
	if (CurrentKey >= strlen(ed->buffer)-2) {
		MacroMode = MACRONONE;
	}
	CurrentFileNo = tmpListNo;
	LineNumber_flag = tmp_LineNumber_flag;
	NumWidth = tmp_NumWidth;

	return key;
}

VOID
SetMacroMode()
{
	register EditLine *ed;
	char buffer[8];
	register int tmpListNo;
	register int tmp_LineNumber_flag;
	register int tmp_NumWidth;
	if (MacroMode == MACROSET) {
		ed = (EditLine *)GetList(GetLastNumber());
		DeleteList(ed);
		MacroMode = MACRONONE;
		return;
	}
	tmpListNo = CurrentFileNo;
	tmp_LineNumber_flag = LineNumber_flag;
	tmp_NumWidth = NumWidth;

	CurrentFileNo = MACRO_SYSTEM;
	MacroMode = MACROSET;
	strcpy(buffer, "  ");
	if ((ed = (EditLine *)MakeLine(buffer)) == NULL) {
		WarningCheck(MEMORY_ERR_MSG);
	} else {
		AppendLast(ed);
	}
	MacroBufferOffset = GetLastNumber();
	CurrentFileNo = tmpListNo;
	LineNumber_flag = tmp_LineNumber_flag;
	NumWidth = tmp_NumWidth;
}
