/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:move.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include "ed.h"


VOID
ResetCursorPosition()
{
	register EditLine *ed;
	if (CursorMode == STOP) {
		ed = (EditLine *)GetList(GetLineOffset());
		if (strlen(ed->buffer) < GetBufferOffset()) {
			SetBufferOffset(strlen(ed->buffer)+1);
		}
		OffsetSetByColum(GetLineOffset());
	}
}

/*-------------------------------------------------------------------
	Cursor up
-------------------------------------------------------------------*/
VOID
CursorUpOp()
{
	CursorUp();
	LineOffsetUp();
	CrtLineUp();
}

/*-------------------------------------------------------------------
	Cursor down
-------------------------------------------------------------------*/
VOID
CursorDownOp()
{
	CursorDown();
	LineOffsetDown();
	CrtLineDown();
}

/*-------------------------------------------------------------------
	Cursor left
-------------------------------------------------------------------*/
VOID
CursorLeftOp()
{
	register EditLine *ed;
	register int tmp_scroll;

	tmp_scroll = GetScroll();
	ResetCursorPosition();
	if (GetBufferOffset() != 1) {
		BuffsetOffsetLeft();
		CursorLeft();
	} else {
		if (GetLineOffset() > 1) {
			LineOffsetUp();
			CursorUp();
			CrtLineUp();
			ed = (EditLine *)GetList(GetLineOffset());
			SetBufferOffset(strlen(ed->buffer)+1);
		}
	}
	if (tmp_scroll != GetScroll()) {
		CrtDrawAll();
	}
}

/*-------------------------------------------------------------------
	Cursor right
-------------------------------------------------------------------*/
VOID
CursorRightOp()
{
	register EditLine *ed;
	register int tmp_scroll;

	tmp_scroll = GetScroll();
	ResetCursorPosition();
	if (CursorMode == STOP) {
		ed = (EditLine *)GetList(GetLineOffset());
		if (GetBufferOffset() <= strlen(ed->buffer)) {
			if (IsKanjiPosition()) {
				BufferOffsetRight();
				CursorRight();
				BufferOffsetRight();
				CursorRight();
			} else {
				BufferOffsetRight();
				CursorRight();
			}
		} else {
			if (GetLineOffset() < GetLastNumber()) {
				CursorDown();
				LineOffsetDown();
				CrtLineDown();
				SetBufferOffset(1);
			}
		}
	} else {
		if (IsKanjiPosition()) {
			BufferOffsetRight();
			CursorRight();
			BufferOffsetRight();
			CursorRight();
		} else {
			BufferOffsetRight();
			CursorRight();
		}
	}
	if (tmp_scroll != GetScroll()) {
		CrtDrawAll();
	}
}

/*-------------------------------------------------------------------
	Cursor jmp to Left Side
-------------------------------------------------------------------*/
VOID
CursorLeftSideOp()
{
	register int scroll;
	scroll = GetScroll();
	CursorLeftSide();
	if (scroll != GetScroll()) {
		CrtDrawAll();
	}
}

/*-------------------------------------------------------------------
	Cursor jmp to Right Side
-------------------------------------------------------------------*/
VOID
CursorRightSideOp()
{
	register int scroll;

	scroll = GetScroll();
	CursorRightSide();

	if (scroll != GetScroll()) {
		CrtDrawAll();
	}
}

/*-------------------------------------------------------------------
	Cursor jmp to Up Side of CRT
-------------------------------------------------------------------*/
VOID
CursorUpSideOp()
{
	if (GetBlockFlg() == ONLINE) {
		CursorUpSide();
		CrtDrawAll();
	} else if (UnderLine_flag == TRUE) {
		CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
		CursorUpSide();
		CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
	} else {
		CursorUpSide();
	}
}

/*-------------------------------------------------------------------
	Cursor jmp to Down Side of CRT
-------------------------------------------------------------------*/
VOID
CursorDownSideOp()
{
	if (GetBlockFlg() == ONLINE) {
		CursorDownSide();
		CrtDrawAll();
	} else if (UnderLine_flag == TRUE) {
		CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
		CursorDownSide();
		CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
	} else {
		CursorDownSide();
	}
}

/*-------------------------------------------------------------------
	Cursor jmp to Top of file
-------------------------------------------------------------------*/
VOID
CursorTopSideOp()
{
	CursorTopSide();
	CrtDrawAll();
}

/*-------------------------------------------------------------------
	Cursor jmp to Last of file
-------------------------------------------------------------------*/
VOID
CursorEndSideOp()
{
	CursorEndSide();
	CrtDrawAll();
}

VOID
RollUpOp()
{
	int i;
	for (i = 0; i < RollWidth; i++) {
		CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
		if (GetLineOffset()-GetRow() <= 0) {
			break;
		}
		LineOffsetUp();
		CrtScrollDown();
		CrtDrawLine(GetRow()+1, GetLineOffset()+1, FALSE);
		CrtDrawLine(GetMinRow(), GetLineOffset()-GetRow()+1, FALSE);
	}
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
}

VOID
RollDownOp()
{
	register long LastOffset;
	register long LineOffset;
	register long Bottom;
	int i;

	LastOffset = GetLastNumber();
	LineOffset = GetLineOffset();
	Bottom = LineOffset + (GetRowWidth() - GetRow());
	for (i = 0; i < RollWidth; i++) {
		CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
		if (LastOffset <= Bottom) {
			break;
		}
		LineOffsetDown();
		CrtScrollUp();
		Bottom++;
		if (GetRow() < GetMinRow()) {
			CrtDrawLine(GetRow()-1, GetLineOffset()-1, FALSE);
		}
		CrtDrawLine(GetMaxRow()-1, GetLineOffset() + (GetRowWidth()-GetRow())-1, FALSE);
	}
	BelowLineDraw();
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
}
