/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:nxedit.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include <ctype.h>
#include "ed.h"
#include "version.h"

static char sccs_veision[] = SCCS_VERSION;

#ifdef	PWNEEDERROR
char Error[1024];
#endif

extern char *GetBlockNames();

/*-------------------------------------------------------------------
	Main Command Loop
-------------------------------------------------------------------*/
VOID
command()
{
	register int key1;
	register int key2;
	register int i;
	register int j;
	register int keyin_flag;
	register int function_flag;

	for (;;) {
		CursorMove();
		key1 = -1;
		key2 = -1;
		key1 = inkey();
		keyin_flag = FALSE;
		function_flag = FALSE;
		keyin_flag = keypadFunction(key1, TRUE);
		if (iscntrl(key1) && keyin_flag == FALSE && key1 != '\t') {
			for (i = 0; i < GetMaxKeyDef() && keyin_flag == FALSE; i++) {
				if (keyDefBuff[i].key1 == key1) {
					if (keyDefBuff[i].key2 == -1) {
						RefreshMessage();
						keyin_flag = TRUE;
						function_flag = TRUE;
						(*funcDefBuff[keyDefBuff[i].funcNo])();
						break;
					} else {
						putDoubleKey(key1);
						CursorMove();
						key2 = inkey();
						if (isalpha(key2)) {
							key2 &= 037;
						}
						delDoubleKey();
						CursorMove();
						for (j = i; j < GetMaxKeyDef(); j++) {
							if (keyDefBuff[j].key1 == key1 && keyDefBuff[j].key2 == key2) {
								RefreshMessage();
								function_flag = TRUE;
								(*funcDefBuff[keyDefBuff[j].funcNo])();
								break;
							}
						}
						keyin_flag = TRUE;
					}
				}
			}
			if (function_flag == FALSE) {
			 	if (MacroMode == MACROSET) {
					RefreshMessage();
					SetMacroKey(key1, key2);
				} else if (MacroMode == MACRONONE) {
					RefreshMessage();
					SearchAndDoMacro(key1, key2);
				}
			}
		} else if (keyin_flag == FALSE) {
			RefreshMessage();
			OffsetSetByColum(GetLineOffset());
			InputAndCrt(key1);
		}
		if (MacroMode == MACROSET) {
			system_msg("MacroMode");
		}
	}
}

/*-------------------------------------------------------------------
	Prcedre of End
-------------------------------------------------------------------*/
VOID
EndProcedure()
{
	move(0, 0);
	CrtNormal(stdscr);
	deleteln();
	refresh();
	endwin();
	SaveSystemHistory();
	SaveShellHistory();
	SaveSearchHistory();
	SaveFileHistory();
	SaveMacro();
	ResetTTY();
	unlink(GetBlockNames());
	exit(0);
}

VOID
main(argc, argv)
register int argc;
char **argv;
{
	register int i;
	int c;
	register int optcount;
	char defpath[MAXPATHLEN+1];
	extern int optind;
	extern char *optarg;
	register int opening_flag = TRUE;
	register int define = TRUE;
	register int preserve_flag = FALSE;

	initscr();
	SetTTY();
	initterm();
	getwsize(2, 3);
	SetSignal();
	SetDefaultOption();
	optcount = 1;
	while ((c = getopt(argc, argv, "jeod:r")) != EOF) {
		switch(c) {
		case 'j':
			setlang = FALSE;
			lang = JAPANESE;
			optcount++;
			break;
		case 'e':
			setlang = FALSE;
			lang = ENGLISH;
			optcount++;
			break;
		case 'o':
			opening_flag=FALSE;
			optcount++;
			break;
		case 'd':
			define=FALSE;
			strcpy(defpath, optarg);
			optcount++;
			optcount++;
			break;
		case 'r':
			preserve_flag=TRUE;
			optcount++;
			break;
		case '?':
			optcount++;
			break;
		}
	}

	if (opening_flag == TRUE) {
		opening();
	}

	SetToNXDEF_Path();
	SetSHELL();
	FileNameInit();
	KeyDefInit();
	if (define == TRUE) {
		ReadDefFile();
	} else {
		ReadDef(defpath);
	}
	if (preserve_flag == TRUE) {
		if (preserve() == FALSE) {
			ResetTTY();
			move(0, 0);
			deleteln();
			refresh();
			endwin();
			exit(0);
		}
	} else {
		if (argc > optcount) {
			system_msg(WAITING_MSG);
			for (i = optcount; i < argc; i++) {
				if (FileOpenOp(argv[i], 0) == FALSE) {
					ResetTTY();
					move(0, 0);
					deleteln();
					refresh();
					endwin();
					_exit(0);
				}
			}
		} else {
			if (Profile_flag == TRUE) {
				ReadProfile();
			} else {
				system_msg(WAITING_MSG);
				FileOpenOp("untitled.txt", 0);
			}
		}
	}
	refreshOpening();
	delopening();
	CrtDrawAll();
	InitSyStemBufferArea();
	InitUndo();
	BlockInitOp();
	ReadSystemHistory();
	ReadShellHistory();
	ReadSearchHistory();
	ReadFileHistory();
	ReadMacro();

	command();
	EndProcedure();
}
