/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:profile.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "ed.h"
#include "version.h"


VOID
SetToNXDEF_Path()
{
	/*Get Enviroment*/
	if ((NxDEFPath = getenv("NXDEF")) == NULL
	&& (NxDEFPath = getenv("HOME")) == NULL) {
		NxDEFPath = "";
	}
}

VOID
ReadProfile()
{

	register FILE *fp;
	char pathname[MAXPATHLEN+2];
	char fname[MAXNAMLEN+2];
	char pathbuff[MAXPATHLEN+1];
	char buffer[MAXLINESTR+2];
	int len;

	sprintf(pathbuff, "%s/.nxprof", NxDEFPath);

	if ((fp = fopen(pathbuff, "r")) != NULL) {
		fgets(buffer, MAXLINESTR+1, fp);
		len = strlen(buffer);
		if (len > 0 && buffer[len-1] == '\n') {
			buffer[len-1] = '\0';
		}
		if (strcmp(buffer, VERSION_MSG) == 0) {
			system_msg(WAITING_MSG);
			while (fgets(pathname, MAXPATHLEN+1, fp) != NULL) {
				fgets(fname, MAXNAMLEN+1, fp);
				len = strlen(pathname);
				if (len > 0 && pathname[len-1] == '\n') {
					pathname[len-1] = '\0';
				}
				len = strlen(fname);
				if (len > 0 && fname[len-1] == '\n') {
					fname[len-1] = '\0';
				}
				if (FileOpenWithFullPath(pathname, fname) == FALSE) {
					break;
				}
			}
		} else {
			system_msg(WAITING_MSG);
			FileOpenOp("untitled.txt", 0);
		}
		fclose(fp);
	} else {
		system_msg(WAITING_MSG);
		FileOpenOp("untitled.txt", 0);
	}

}

VOID
SaveProfile()
{
	register int i;
	char pathbuff[MAXPATHLEN+1];
	register FILE *fp;

	if (Profile_flag == FALSE) {
		return;
	}
	sprintf(pathbuff, "%s/.nxprof", NxDEFPath);
	/*Save "nxedit.def" and Set Option's*/
	if ((fp = fopen(pathbuff, "w")) != NULL) {
		fprintf(fp, "%s\n", VERSION_MSG);
		for (i = FILE_START; i < MAXEDIT; i++) {
			if (EditPathName[i][0] != '\0') {
				fprintf(fp, "%s\n", EditPathName[i]);
				fprintf(fp, "%s\n", EditFileName[i]);
			}
		}
		fclose(fp);
	}
}

VOID
ReadFileHistory()
{
	char pathbuff[MAXPATHLEN+1];
	char buffer[MAXEDITLINE+2];
	register FILE *fp;
	register int	tmpFileno;
	register EditLine *ed;
	int len;

	if (HistoryRead_flag == FALSE) {
		return;
	}
	tmpFileno = CurrentFileNo;

	CurrentFileNo = FOPEN_SYSTEM;

	sprintf(pathbuff, "%s/.nx.file.his", NxDEFPath);

	if ((fp = fopen(pathbuff, "r")) != NULL) {
		fgets(buffer, MAXLINESTR+1, fp);
		len = strlen(buffer);
		if (len > 0 && buffer[len-1] == '\n') {
			buffer[len-1] = '\0';
		}
		if (strcmp(buffer, VERSION_MSG) == 0) {
			while (fgets(buffer, MAXEDITLINE+1, fp) != NULL) {
				len = strlen(buffer);
				if (len > 0 && buffer[len-1] == '\n') {
					buffer[len-1] = '\0';
				}
				if ((ed = (EditLine *)MakeLine(buffer)) == NULL) {
					WhileKbHit(MEMORY_ERR_MSG);
					break;
				} else {
					AppendLast(ed);
				}
			}
		}
		fclose(fp);
	}
	CurrentFileNo = tmpFileno;
}

VOID
SaveFileHistory()
{
	char pathbuff[MAXPATHLEN+1];
	register FILE *fp;
	register int	tmpFileno;
	register EditLine *ed;

	if (HistorySave_flag == FALSE) {
		return;
	}
	tmpFileno = CurrentFileNo;
	CurrentFileNo = FOPEN_SYSTEM;

	sprintf(pathbuff, "%s/.nx.file.his", NxDEFPath);
	/*Save "nxedit.def" and Set Option's*/
	if ((fp = fopen(pathbuff, "w")) != NULL) {
		fprintf(fp, "%s\n", VERSION_MSG);
		LineOffsetSet(GetLastNumber()-SaveHistoryNumber-1);
		ed = (EditLine *)GetList(GetLineOffset());

		while (ed->next != NULL) {
			fprintf(fp, "%s\n", ed->buffer);
			ed = ed->next;
		}
		if (ed->buffer != NULL) {
			fprintf(fp, "%s\n", ed->buffer);
		}
		fclose(fp);
	}
	CurrentFileNo = tmpFileno;
}

VOID
ReadSearchHistory()
{
	char pathbuff[MAXPATHLEN+1];
	char buffer[MAXEDITLINE+2];
	register FILE *fp;
	register int	tmpFileno;
	register EditLine *ed;
	int len;

	if (HistoryRead_flag == FALSE) {
		return;
	}
	tmpFileno = CurrentFileNo;

	CurrentFileNo = SEARCHS_SYSTEM;

	sprintf(pathbuff, "%s/.nx.search.his", NxDEFPath);

	if ((fp = fopen(pathbuff, "r")) != NULL) {
		fgets(buffer, MAXLINESTR+1, fp);
		len = strlen(buffer);
		if (len > 0 && buffer[len-1] == '\n') {
			buffer[len-1] = '\0';
		}
		if (strcmp(buffer, VERSION_MSG) == 0) {
			while (fgets(buffer, MAXEDITLINE+1, fp) != NULL) {
				len = strlen(buffer);
				if (len > 0 && buffer[len-1] == '\n') {
					buffer[len-1] = '\0';
				}
				if ((ed = (EditLine *)MakeLine(buffer)) == NULL) {
					WhileKbHit(MEMORY_ERR_MSG);
					break;
				} else {
					AppendLast(ed);
				}
			}
		}
		fclose(fp);
	}
	CurrentFileNo = tmpFileno;
}

VOID
SaveSearchHistory()
{
	char pathbuff[MAXPATHLEN+1];
	register FILE *fp;
	register int	tmpFileno;
	register EditLine *ed;

	if (HistorySave_flag == FALSE) {
		return;
	}
	tmpFileno = CurrentFileNo;
	CurrentFileNo = SEARCHS_SYSTEM;


	sprintf(pathbuff, "%s/.nx.search.his", NxDEFPath);

	/*Save "nxedit.def" and Set Option's*/
	if ((fp = fopen(pathbuff, "w")) != NULL) {
		fprintf(fp, "%s\n", VERSION_MSG);
		LineOffsetSet(GetLastNumber()-SaveHistoryNumber-1);
		ed = (EditLine *)GetList(GetLineOffset());

		while (ed->next != NULL) {
			fprintf(fp, "%s\n", ed->buffer);
			ed = ed->next;
		}
		if (ed->buffer != NULL) {
			fprintf(fp, "%s\n", ed->buffer);
		}
		fclose(fp);
	}
	CurrentFileNo = tmpFileno;
}

VOID
ReadShellHistory()
{
	char pathbuff[MAXPATHLEN+1];
	char buffer[MAXEDITLINE+2];
	register FILE *fp;
	register int	tmpFileno;
	register EditLine *ed;
	int len;

	if (HistoryRead_flag == FALSE) {
		return;
	}
	tmpFileno = CurrentFileNo;

	CurrentFileNo = SHELLS_SYSTEM;

	sprintf(pathbuff, "%s/.nx.shell.his", NxDEFPath);

	if ((fp = fopen(pathbuff, "r")) != NULL) {
		fgets(buffer, MAXLINESTR+1, fp);
		len = strlen(buffer);
		if (len > 0 && buffer[len-1] == '\n') {
			buffer[len-1] = '\0';
		}
		if (strcmp(buffer, VERSION_MSG) == 0) {
			while (fgets(buffer, MAXEDITLINE+1, fp) != NULL) {
				len = strlen(buffer);
				if (len > 0 && buffer[len-1] == '\n') {
					buffer[len-1] = '\0';
				}
				if ((ed = (EditLine *)MakeLine(buffer)) == NULL) {
					WhileKbHit(MEMORY_ERR_MSG);
					break;
				} else {
					AppendLast(ed);
				}
			}
		}
		fclose(fp);
	}
	CurrentFileNo = tmpFileno;
}

VOID
SaveShellHistory()
{
	char pathbuff[MAXPATHLEN+1];
	register FILE *fp;
	register int	tmpFileno;
	register EditLine *ed;

	if (HistorySave_flag == FALSE) {
		return;
	}
	tmpFileno = CurrentFileNo;
	CurrentFileNo = SHELLS_SYSTEM;


	sprintf(pathbuff, "%s/.nx.shell.his", NxDEFPath);

	/*Save "nxedit.def" and Set Option's*/
	if ((fp = fopen(pathbuff, "w")) != NULL) {
		fprintf(fp, "%s\n", VERSION_MSG);
		LineOffsetSet(GetLastNumber()-SaveHistoryNumber-1);
		ed = (EditLine *)GetList(GetLineOffset());

		while (ed->next != NULL) {
			fprintf(fp, "%s\n", ed->buffer);
			ed = ed->next;
		}
		if (ed->buffer != NULL) {
			fprintf(fp, "%s\n", ed->buffer);
		}
		fclose(fp);
	}
	CurrentFileNo = tmpFileno;
}

VOID
ReadSystemHistory()
{
	char pathbuff[MAXPATHLEN+1];
	char buffer[MAXEDITLINE+2];
	register FILE *fp;
	register int	tmpFileno;
	register EditLine *ed;
	int len;

	if (HistoryRead_flag == FALSE) {
		return;
	}
	tmpFileno = CurrentFileNo;

	CurrentFileNo = SYSTEM_SYSTEM;

	sprintf(pathbuff, "%s/.nx.system.his", NxDEFPath);

	if ((fp = fopen(pathbuff, "r")) != NULL) {
		fgets(buffer, MAXLINESTR+1, fp);
		len = strlen(buffer);
		if (len > 0 && buffer[len-1] == '\n') {
			buffer[len-1] = '\0';
		}
		if (strcmp(buffer, VERSION_MSG) == 0) {
			while (fgets(buffer, MAXEDITLINE+1, fp) != NULL) {
				len = strlen(buffer);
				if (len > 0 && buffer[len-1] == '\n') {
					buffer[len-1] = '\0';
				}
				if ((ed = (EditLine *)MakeLine(buffer)) == NULL) {
					WhileKbHit(MEMORY_ERR_MSG);
					break;
				} else {
					AppendLast(ed);
				}
			}
		}
		fclose(fp);
	}
	CurrentFileNo = tmpFileno;
}

VOID
SaveSystemHistory()
{
	char pathbuff[MAXPATHLEN+1];
	register FILE *fp;
	register int	tmpFileno;
	register EditLine *ed;

	if (HistorySave_flag == FALSE) {
		return;
	}
	tmpFileno = CurrentFileNo;
	CurrentFileNo = SYSTEM_SYSTEM;


	sprintf(pathbuff, "%s/.nx.system.his", NxDEFPath);

	/*Save "nxedit.def" and Set Option's*/
	if ((fp = fopen(pathbuff, "w")) != NULL) {
		fprintf(fp, "%s\n", VERSION_MSG);
		LineOffsetSet(GetLastNumber()-SaveHistoryNumber-1);
		ed = (EditLine *)GetList(GetLineOffset());

		while (ed->next != NULL) {
			fprintf(fp, "%s\n", ed->buffer);
			ed = ed->next;
		}
		if (ed->buffer != NULL) {
			fprintf(fp, "%s\n", ed->buffer);
		}
		fclose(fp);
	}
	CurrentFileNo = tmpFileno;
}

VOID
ReadMacro()
{
}

VOID
SaveMacro()
{
}
