/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:search.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include <ctype.h>
#include "ed.h"

#define	ALLOFFILE	0
#define	FORWARDCURSOR	1
#define	BACKCURSOR	2
#define	INSIDEBLOCK	3
static long chgNo;
static int ChangAreaFlg;
static int CheckFlg;
static char searchs[MAXEDITLINE+1];
static char changes[MAXEDITLINE+1];
static int searchlen;
static int changelen;

static int
SearchSetDraw(LineOffset, ColOffset, targetlen)
register long LineOffset;
register int ColOffset;
register int targetlen;
{
	register int DrawFlag;
	register int tmpscroll;

	DrawFlag = FALSE;

	tmpscroll = GetScroll();

	if (LineOffset != GetLineOffset()) {
		if (LineOffset < GetLineOffset()) {
		/* target before current line */
			while (GetLineOffset() > LineOffset) {
				if (GetRow() > GetMinRow()) {
					CursorSetRow(GetRow()-1);
				} else {
					DrawFlag = TRUE;
				}
				LineOffsetUp();
			}
		} else {
		/* target after current line */
			while (GetLineOffset() < LineOffset) {
				if (GetRow() < GetMaxRow()-1) {
					CursorSetRow(GetRow()+1);
				} else {
					DrawFlag = TRUE;
				}
				LineOffsetDown();
			}
		}
	}
	if (ColOffset != GetBufferOffset()) {
		if (ColOffset < GetBufferOffset()) {
		/* target before current line */
			while (GetBufferOffset() > ColOffset) {
				ResetCursorPosition();
				BuffsetOffsetLeft();
				CursorLeft();
			}
		} else {
		/* target after current line */
			while (GetBufferOffset() < ColOffset+targetlen) {
				ResetCursorPosition();
				if (IsKanjiPosition()) {
					BufferOffsetRight();
					CursorRight();
					BufferOffsetRight();
					CursorRight();
				} else {
					BufferOffsetRight();
					CursorRight();
				}
			}
		}
	}
	LineOffsetSet(LineOffset);
	SetBufferOffset(ColOffset);
	CursorSetByColOffset();
	if (tmpscroll != GetScroll()) {
		DrawFlag = TRUE;
	}
	if (GetBlockFlg() == ONLINE) {
		DrawFlag = TRUE;
	}

	return DrawFlag;
}

static int
SearchSetDrawAndDraw(LineOffset, ColOffset, targetlen)
register long LineOffset;
register int ColOffset;
register int targetlen;
{
	if (LineOffset == GetLineOffset() && ColOffset == GetBufferOffset()) {
		return FALSE;
	}
	if (SearchSetDraw(LineOffset, ColOffset, targetlen) == TRUE) {
		CrtDrawAll();
	}
	return TRUE;
}

/*-------------------------------------------------------------------
	buffer
	target
-------------------------------------------------------------------*/
char *
strsearch_n(buffer, target, col)
char *buffer;
char *target;
register int *col;
{
	register int i;
	register int j;
	register int colum;
	register int strlength;
	int c1, c2, kanji2;

	colum = *col;
	strlength = strlen(buffer);
	for (i = colum; i < strlength; i++) {
		kanji2 = FALSE;
		for (j = 0; target[j] != '\0'; j++) {
			if (buffer[i+j] == target[j]) {
				kanji2 = IsKanji(target[j]);
			} else {
				if (SearchStrCharMode == DIVIDE || kanji2
				|| IsKanji(buffer[i+j]) || IsKanji(target[j])) {
					break;
				}
				c1 = buffer[i+j];
				c2 = target[j];
				if (islower(c1)) c1 += 'A' - 'a';
				if (islower(c2)) c2 += 'A' - 'a';
				if (c1 != c2) {
					break;
				}
				kanji2 = FALSE;
			}
		}
		if (target[j] == '\0') {
			*col = i+1;
			return buffer;
		}
		if (IsKanji(buffer[i])) {
			i++;
		}
	}
	return NULL;
}

/*-------------------------------------------------------------------
	buffer
	target
-------------------------------------------------------------------*/
char *
strsearch_b(buffer, target, bufferlen, targetlen, col)
char *buffer;
char *target;
register int bufferlen;
register int targetlen;
register int *col;
{
	register int i;
	register int j;
	register int colum;
	int c1, c2, kanji2;

	for (colum = min(bufferlen, *col-2); colum > 0; colum--) {
		for (i = 0; i < colum; i++) {
			if (IsKanji(buffer[i])) {
				if (i+1 >= colum) {
					break;
				}
				i++;
			}
		}
		colum = i;
		kanji2 = FALSE;
		for (j = 0; target[j] != '\0'; j++) {
			if (buffer[i+j] == target[j]) {
				kanji2 = IsKanji(target[j]);
			} else {
				if (SearchStrCharMode == DIVIDE || kanji2
				|| IsKanji(buffer[i+j]) || IsKanji(target[j])) {
					break;
				}
				c1 = buffer[i+j];
				c2 = target[j];
				if (islower(c1)) c1 += 'A' - 'a';
				if (islower(c2)) c2 += 'A' - 'a';
				if (c1 != c2) {
					break;
				}
				kanji2 = FALSE;
			}
		}
		if (target[j] == '\0') {
			*col = i+1;
			return buffer;
		}
	}
	return NULL;
}

/*-------------------------------------------------------------------
-------------------------------------------------------------------*/
long
search_next(number, target, col)
register long number;
char *target;
register int *col;
{

	int colum;
	register long num;
	register long LastOffset;
	register EditLine *ed;

	colum = 0;
	num = number+1;
	ed = (EditLine *)GetList(number);

	LastOffset = GetLastNumber();
	if (strsearch_n(ed->buffer, target, col) != NULL) {
		return number;
	}
	if (number+1 <= LastOffset) {
		ed = ed->next;
		while (strsearch_n(ed->buffer, target, &colum) == NULL) {
			if (num+1 <= LastOffset) {
				num++;
				ed = ed->next;
			} else {
				return number;
			}
		}
		*col = colum;
		return num;
	} else {
		return number;
	}
}

/*-------------------------------------------------------------------
-------------------------------------------------------------------*/
long
search_behind(number, target, col)
register long number;
char *target;
register int *col;
{
	int colum;
	register long num;
	register EditLine *ed;

	ed = (EditLine *)GetList(number);
	if (strsearch_b(ed->buffer, target, strlen(ed->buffer)+1, searchlen, col) != NULL) {
		return number;
	}
	if (number-1 > 0) {
		num = number-1;
		ed = ed->behind;
	} else {
		return number;
	}
	colum = strlen(ed->buffer)+1;
	while (strsearch_b(ed->buffer, target, colum, searchlen, &colum) == NULL) {
		num--;
		if (num == 0) {
			return number;
		}
		ed = ed->behind;
		colum = strlen(ed->buffer)+1;
	}
	*col = colum;
	return num;
}

/*-------------------------------------------------------------------
-------------------------------------------------------------------*/
int
SearchBack()
{
	int ColOffset;
	register long LineOffset;

	LineOffset = GetLineOffset();
	ColOffset = GetBufferOffset();

	searchlen = strlen(searchs);
	if (searchlen == 0) {
		if (HisGets(searchs, GETS_FIND_MSG, SEARCHS_SYSTEM) == NULL) {
			return ESCAPE;
		}
		searchlen = strlen(searchs);
	}
	system_msg(SEARCHING_MSG);

	LineOffset = search_behind(LineOffset, searchs, &ColOffset);
	if (SearchSetDrawAndDraw(LineOffset, ColOffset, searchlen) == FALSE) {
		return FALSE;
	}
	return TRUE;
}

int
SearchForward()
{
	int ColOffset;
	register long LineOffset;
	LineOffset = GetLineOffset();
	ColOffset = GetBufferOffset();

	searchlen = strlen(searchs);
	CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
	if (searchlen == 0) {
		if (HisGets(searchs, GETS_FIND_MSG, SEARCHS_SYSTEM) == NULL) {
			/*BelowLineDraw();*/
			CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
			return ESCAPE;
		}
		searchlen = strlen(searchs);
	}
	system_msg(SEARCHING_MSG);
	LineOffset = search_next(LineOffset, searchs, &ColOffset);

	if (SearchSetDrawAndDraw(LineOffset, ColOffset, searchlen) == FALSE) {
		CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
		return FALSE;
	}
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
	return TRUE;
}

int
SearchInForward()
{
	int ColOffset;
	register long LineOffset;

	LineOffset = GetLineOffset();
	ColOffset = GetBufferOffset();

	CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
	if (HisGets(searchs, GETS_FIND_MSG, SEARCHS_SYSTEM) == NULL) {
		/*BelowLineDraw();*/
		return ESCAPE;
	}
	searchlen = strlen(searchs);
	system_msg(SEARCHING_MSG);
	LineOffset = search_next(LineOffset, searchs, &ColOffset);

	if (SearchSetDrawAndDraw(LineOffset, ColOffset, searchlen) == FALSE) {
		CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
		return FALSE;
	}
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
	return TRUE;
}

int
SearchInBack()
{
	int ColOffset;
	register long LineOffset;

	LineOffset = GetLineOffset();
	ColOffset = GetBufferOffset();

	if (HisGets(searchs, GETS_FIND_MSG, SEARCHS_SYSTEM) == NULL) {
		/*BelowLineDraw();*/
		return ESCAPE;
	}
	searchlen = strlen(searchs);
	system_msg(SEARCHING_MSG);
	LineOffset = search_behind(LineOffset, searchs, &ColOffset);

	if (SearchSetDrawAndDraw(LineOffset, ColOffset, searchlen) == FALSE) {
		return FALSE;
	}
	return TRUE;
}

int
ChangeStringBack(StartOffset, EndOffset)
register long StartOffset;
register long EndOffset;
{
	register int i;
	register int result;
	int ColOffset;
	register long LineOffset;

	for (LineOffset = StartOffset; EndOffset <= LineOffset; LineOffset = GetLineOffset()) {
		ColOffset = GetBufferOffset();
		SearchSetDraw(LineOffset, ColOffset, "");
		CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
		LineOffset = search_behind(LineOffset, searchs, &ColOffset);
		if (LineOffset < EndOffset) {
			return TRUE;
		}

		if (LineOffset != GetLineOffset() || ColOffset != GetBufferOffset()) {
			if (CheckFlg == TRUE) {
				SearchSetDraw(LineOffset, ColOffset, searchlen);
				CrtDrawAll();
				CursorMove();
				move(GetRow(), GetCol()+NumWidth-1);
				CrtNormal(stdscr);
				CrtReverse(stdscr);
				addstr(searchs);
				result = UserIsYes(REPLACE_MSG);
				if (result == TRUE) {
					for (i = 0; i < searchlen; i++) {
						Ledit(INSERT, CursorMode, DELETE);
					}
					for (i = 0; i < changelen; i++) {
						LeditInput(changes[i], INSERT, CursorMode, NONE);
					}
					chgNo++;
					system_msg(SEARCHING_MSG);
					SetFileChangeFlag();
				} else if (result == ESCAPE) {
					return ESCAPE;
				}
				SetBufferOffset(ColOffset);
			} else {
				LineOffsetSet(LineOffset);
				CursorSetScroll(0);
				SetBufferOffset(ColOffset);
				for (i = 0; i < searchlen; i++) {
					Ledit(INSERT, CursorMode, DELETE);
				}
				for (i = 0; i < changelen; i++) {
					LeditInput(changes[i], INSERT, CursorMode, NONE);
				}
				SetBufferOffset(ColOffset);
				chgNo++;
				SetFileChangeFlag();
			}
			CursorSetByColOffset();
		} else {
			break;
		}
	}
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
	return TRUE;
}

int
ChangeStringForward(StartOffset, EndOffset)
register long StartOffset;
register long EndOffset;
{
	register int i;
	register int result;
	int ColOffset;
	register long LineOffset;

	for (LineOffset = StartOffset; LineOffset <= EndOffset; LineOffset = GetLineOffset()) {
		ColOffset = GetBufferOffset()-1;
		SearchSetDraw(LineOffset, ColOffset+1, "");
		CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
		LineOffset = search_next(LineOffset, searchs, &ColOffset);
		if (LineOffset > EndOffset) {
			return TRUE;
		}

		if (LineOffset != GetLineOffset() || ColOffset != GetBufferOffset()-1) {
			if (CheckFlg == TRUE) {
				SearchSetDraw(LineOffset, ColOffset, searchlen);
				CrtDrawAll();
				CursorMove();
				move(GetRow(), GetCol()+NumWidth-1);
				CrtNormal(stdscr);
				CrtReverse(stdscr);
				addstr(searchs);
				result = UserIsYes(REPLACE_MSG);
				if (result == TRUE) {
					for (i = 0; i < searchlen; i++) {
						Ledit(INSERT, CursorMode, DELETE);
					}
					for (i = 0; i < changelen; i++) {
						LeditInput(changes[i], INSERT, CursorMode, NONE);
					}
					chgNo++;
					system_msg(SEARCHING_MSG);
					SetFileChangeFlag();
				} else if (result == ESCAPE) {
					return ESCAPE;
				}
				SetBufferOffset(ColOffset+changelen);
			} else {
				LineOffsetSet(LineOffset);
				CursorSetScroll(0);
				SetBufferOffset(ColOffset);
				for (i = 0; i < searchlen; i++) {
					Ledit(INSERT, CursorMode, DELETE);
				}
				for (i = 0; i < changelen; i++) {
					LeditInput(changes[i], INSERT, CursorMode, NONE);
				}
				SetBufferOffset(ColOffset+changelen);
				chgNo++;
				SetFileChangeFlag();
			}
			CursorSetByColOffset();
		} else {
			break;
		}

	}
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
	return TRUE;
}

int
ChangeString()
{
	register int row;
	register int col;
	register int result;
	register int BackColOffset;
	register long BackLineOffset;
	char buffer[MAXLINESTR+1];
	register long b_start;
	register long b_end;

	chgNo = 0;
	row = GetRow();
	col = GetCol();
	BackColOffset = GetBufferOffset();
	BackLineOffset = GetLineOffset();

	system_msg(SEARCHING_MSG);

	switch(ChangAreaFlg) {
	case ALLOFFILE:
		SetBufferOffset(0);
		CursorSetCol(0);
		result = ChangeStringForward(GetTopNumber(), GetLastNumber());
		if (result == ESCAPE) {
			CursorSetRow(row);
			CursorSetCol(col);
			LineOffsetSet(BackLineOffset);
			SetBufferOffset(BackColOffset);
			CrtDrawAll();
			return FALSE;
		}
		break;
	case FORWARDCURSOR:
		result = ChangeStringForward(GetLineOffset(), GetLastNumber());
		if (result == ESCAPE) {
			CursorSetRow(row);
			CursorSetCol(col);
			LineOffsetSet(BackLineOffset);
			SetBufferOffset(BackColOffset);
			CrtDrawAll();
			return FALSE;
		}
		break;
	case BACKCURSOR:
		result = ChangeStringBack(GetLineOffset(), GetTopNumber());
		if (result == ESCAPE) {
			CursorSetRow(row);
			CursorSetCol(col);
			LineOffsetSet(BackLineOffset);
			SetBufferOffset(BackColOffset);
			CrtDrawAll();
			return FALSE;
		}
		break;
	case INSIDEBLOCK:
		b_start = min(GetBlockStart(), GetBlockEnd());
		b_end = max(GetBlockStart(), GetBlockEnd());
		BlockInitOp();
		CrtDrawAll();
		SetBufferOffset(0);
		CursorSetCol(0);
		JmpNumber(b_start);
		result = ChangeStringForward(GetLineOffset(), b_end);
		if (result == ESCAPE) {
			CursorSetRow(row);
			CursorSetCol(col);
			LineOffsetSet(BackLineOffset);
			SetBufferOffset(BackColOffset);
			CrtDrawAll();
			return FALSE;
		}
		break;
	}

	CursorSetRow(row);
	CursorSetCol(col);
	LineOffsetSet(BackLineOffset);
	SetBufferOffset(BackColOffset);
	CrtDrawAll();
	sprintf(buffer, "[ %.30s -> %-.30s ] %ld %s...", searchs, changes, chgNo, REPLACED_MSG);
	system_msg(buffer);
	return TRUE;

}

VOID
RepeatChangeOperation()
{
	ChangAreaFlg = ALLOFFILE;
	ChangeString();
}

int
MultiFileSearch()
{
	register int i;
	register int tmpFileNo;
	register int row;
	register int col;
	register int BackColOffset;
	register long BackLineOffset;
	register int row2;
	register int col2;
	register int BackColOffset2;
	register long BackLineOffset2;
	int ColOffset;
	register long LineOffset;


	CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
	searchlen = strlen(searchs);
	if (searchlen == 0) {
		if (HisGets(searchs, GETS_FIND_MSG, SEARCHS_SYSTEM) == NULL) {
			/*BelowLineDraw();*/
			CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
			return ESCAPE;
		}
		searchlen = strlen(searchs);
	}
	system_msg(SEARCHING_MSG);

	row = GetRow();
	col = GetCol();
	BackColOffset = GetBufferOffset();
	BackLineOffset = GetLineOffset();

	tmpFileNo = CurrentFileNo;
	for (i = CurrentFileNo; i < MAXEDIT; i++) {
		if (EditPathName[i][0] != '\0') {
			CurrentFileNo = i;
			row2 = GetRow();
			col2 = GetCol();
			BackColOffset2 = GetBufferOffset();
			BackLineOffset2 = GetLineOffset();
			if (tmpFileNo != CurrentFileNo) {
				CursorTopSide();
				SetBufferOffset(searchlen+1);
				CursorSetCol(searchlen+1);

				LineOffset = GetLineOffset();
				ColOffset = GetBufferOffset();
				LineOffset = search_behind(LineOffset, searchs, &ColOffset);
				if (LineOffset != GetLineOffset() || ColOffset != GetBufferOffset()) {
					if (SearchSetDraw(LineOffset, ColOffset, searchlen) == TRUE) {
						CrtDrawAll();
					}
					system_msg(FOUND_MSG);
					return TRUE;
				}
				SetBufferOffset(0);
				CursorSetCol(0);
			}
			LineOffset = GetLineOffset();
			ColOffset = GetBufferOffset();
			LineOffset = search_next(LineOffset, searchs, &ColOffset);
			if (LineOffset != GetLineOffset() || ColOffset != GetBufferOffset()) {
				if (SearchSetDraw(LineOffset, ColOffset, searchlen) == TRUE || tmpFileNo != CurrentFileNo) {
					CrtDrawAll();
				}
				system_msg(FOUND_MSG);
				CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
				return TRUE;
			}
			CursorSetRow(row2);
			CursorSetCol(col2);
			LineOffsetSet(BackLineOffset2);
			SetBufferOffset(BackColOffset2);
		}
	}
	for (i = FILE_START; i < tmpFileNo; i++) {
		if (EditPathName[i][0] != '\0') {
			CurrentFileNo = i;
			row2 = GetRow();
			col2 = GetCol();
			BackColOffset2 = GetBufferOffset();
			BackLineOffset2 = GetLineOffset();
			if (tmpFileNo != CurrentFileNo) {
				CursorTopSide();
				SetBufferOffset(searchlen+1);
				CursorSetCol(searchlen+1);
				LineOffset = GetLineOffset();
				ColOffset = GetBufferOffset();
				LineOffset = search_behind(LineOffset, searchs, &ColOffset);
				if (LineOffset != GetLineOffset() || ColOffset != GetBufferOffset()) {
					if (SearchSetDraw(LineOffset, ColOffset, searchlen) == TRUE) {
						CrtDrawAll();
					}
					system_msg(FOUND_MSG);
					return TRUE;
				}
				SetBufferOffset(0);
				CursorSetCol(0);
			}
			LineOffset = GetLineOffset();
			ColOffset = GetBufferOffset();
			LineOffset = search_next(LineOffset, searchs, &ColOffset);
			if (LineOffset != GetLineOffset() || ColOffset != GetBufferOffset()) {
				if (SearchSetDraw(LineOffset, ColOffset, searchlen) == TRUE || tmpFileNo != CurrentFileNo) {
					CrtDrawAll();
				}
				system_msg(FOUND_MSG);
				CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
				return TRUE;
			}
			CursorSetRow(row2);
			CursorSetCol(col2);
			LineOffsetSet(BackLineOffset2);
			SetBufferOffset(BackColOffset2);
		}
	}
	CurrentFileNo = tmpFileNo;
	CursorSetRow(row);
	CursorSetCol(col);
	LineOffsetSet(BackLineOffset);
	SetBufferOffset(BackColOffset);
	system_msg(NOT_FOUND_MSG);
	return FALSE;
}

int
MultiFileChange()
{
	register int i;
	register int tmpFileNo;
	register int row;
	register int col;
	register int result;
	register int BackColOffset;
	register long BackLineOffset;
	register int row2;
	register int col2;
	register int BackColOffset2;
	register long BackLineOffset2;

	row = GetRow();
	col = GetCol();
	BackColOffset = GetBufferOffset();
	BackLineOffset = GetLineOffset();
	tmpFileNo = CurrentFileNo;
	CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
	result = UserIsYes(REPLACE_WITH_ASK_MSG);
	if (result == ESCAPE) {
		CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
		return FALSE;
	} else {
		CheckFlg = result;
		ChangAreaFlg = FORWARDCURSOR;
	}
	if (HisGets(searchs, GETS_FIND_MSG, SEARCHS_SYSTEM) == NULL) {
		/*BelowLineDraw();*/
		CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
		return FALSE;
	}
	searchlen = strlen(searchs);
	if (HisGets(changes, GETS_REPLACE_MSG, SEARCHS_SYSTEM) == NULL) {
		/*BelowLineDraw();*/
		CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
		return FALSE;
	}
	changelen = strlen(changes);
	system_msg(SEARCHING_MSG);
	for (i = CurrentFileNo; i < MAXEDIT; i++) {
		if (EditPathName[i][0] != '\0') {
			CurrentFileNo = i;
			row2 = GetRow();
			col2 = GetCol();
			BackColOffset2 = GetBufferOffset();
			BackLineOffset2 = GetLineOffset();
			CursorTopSide();
			SetBufferOffset(0);
			CursorSetCol(0);
			if (ChangeStringForward(GetTopNumber(), GetLastNumber()) == ESCAPE) {
				CursorSetRow(row2);
				CursorSetCol(col2);
				LineOffsetSet(BackLineOffset2);
				SetBufferOffset(BackColOffset2);
				CurrentFileNo = tmpFileNo;
				CursorSetRow(row);
				CursorSetCol(col);
				LineOffsetSet(BackLineOffset);
				SetBufferOffset(BackColOffset);
				CrtDrawAll();
				return FALSE;
			}
			CursorSetRow(row2);
			CursorSetCol(col2);
			LineOffsetSet(BackLineOffset2);
			SetBufferOffset(BackColOffset2);
		}
	}
	for (i = FILE_START; i < tmpFileNo; i++) {
		if (EditPathName[i][0] != '\0') {
			CurrentFileNo = i;
			row2 = GetRow();
			col2 = GetCol();
			BackColOffset2 = GetBufferOffset();
			BackLineOffset2 = GetLineOffset();
			CursorTopSide();

			SetBufferOffset(0);
			CursorSetCol(0);
			if (ChangeStringForward(GetTopNumber(), GetLastNumber()) == ESCAPE) {
			CurrentFileNo = tmpFileNo;
				CursorSetRow(row);
				CursorSetCol(col);
				LineOffsetSet(BackLineOffset);
				SetBufferOffset(BackColOffset);
				CrtDrawAll();
				return FALSE;
			}
			CursorSetRow(row2);
			CursorSetCol(col2);
			LineOffsetSet(BackLineOffset2);
			SetBufferOffset(BackColOffset2);
		}
	}
	CurrentFileNo = tmpFileNo;
	CursorSetRow(row);
	CursorSetCol(col);
	LineOffsetSet(BackLineOffset);
	SetBufferOffset(BackColOffset);
	CrtDrawAll();
	return FALSE;
}

static int m_select = 0;
VOID
ChangeStringMenu()
{
	char tmpbuff[5][20];
	char *buff[5];
	register int result;
	register int res;

	strcpy(tmpbuff[0], REPLACE_ALL_MSG);
	strcpy(tmpbuff[1], REPLACE_FORWARD_MSG);
	strcpy(tmpbuff[2], REPLACE_BACK_MSG);
	strcpy(tmpbuff[3], REPLACE_INSIDEBLOCK_MSG);
	buff[0] = tmpbuff[0];
	buff[1] = tmpbuff[1];
	buff[2] = tmpbuff[2];
	buff[3] = tmpbuff[3];

	CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
	if (GetBlockFlg() == ONLINE) {
		NumMenu_open(GetRow(), GetCol(), buff, 4);
		res = NumMenu_select(GetRow(), GetCol(), buff, 4, m_select);
	} else {
		if (m_select == 3) {
			m_select = 0;
		}
		NumMenu_open(GetRow(), GetCol(), buff, 3);
		res = NumMenu_select(GetRow(), GetCol(), buff, 3, m_select);
	}
	switch(res) {
	case -1:
		CrtDrawAll();
		return;
		break;
	case 0:
		ChangAreaFlg = ALLOFFILE;
		break;
	case 1:
		ChangAreaFlg = FORWARDCURSOR;
		break;
	case 2:
		ChangAreaFlg = BACKCURSOR;
		break;
	case 3:
		ChangAreaFlg = INSIDEBLOCK;
		break;
	}
	m_select = res;
	CrtDrawAll();
	result = UserIsYes(REPLACE_WITH_ASK_MSG);
	if (result != ESCAPE) {
		if (HisGets(searchs, GETS_FIND_MSG, SEARCHS_SYSTEM) == NULL) {
			/*BelowLineDraw();*/
			CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
			return;
		}
		searchlen = strlen(searchs);
		if (HisGets(changes, GETS_REPLACE_MSG, SEARCHS_SYSTEM) == NULL) {
			/*BelowLineDraw();*/
			CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
			return;
		}
		changelen = strlen(changes);
		CheckFlg = result;
		ChangeString();
	}
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
}

char *
GetSearchStr()
{
	return searchs;
}

char *
GetChangeStr()
{
	return changes;
}

char *
SetSearchStr(buffer)
char *buffer;
{
	strcpy(searchs, buffer);
}

char *
SetChangeStr(buffer)
char *buffer;
{
	strcpy(changes, buffer);
}

/*-------------------------------------------------------------------
	Search Before
-------------------------------------------------------------------*/
VOID
SearchBackOp()
{
	int res;

	CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
	res = SearchBack();
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
	if (res == TRUE) {
		system_msg(FOUND_MSG);
	} else if (res == FALSE) {
		system_msg(NOT_FOUND_MSG);
	}
}

/*-------------------------------------------------------------------
	Search Next
-------------------------------------------------------------------*/
VOID
SearchForwardOp()
{
	int res;

	CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
	res = SearchForward();
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
	if (res == TRUE) {
		system_msg(FOUND_MSG);
	} else if (res == FALSE) {
		system_msg(NOT_FOUND_MSG);
	}

}

/*-------------------------------------------------------------------
	Search string Input and Search before
-------------------------------------------------------------------*/
VOID
SearchInForwardOp()
{
	int res;

	CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
	res = SearchInForward();
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
	if (res == TRUE) {
		system_msg(FOUND_MSG);
	} else if (res == FALSE) {
		system_msg(NOT_FOUND_MSG);
	}
}

VOID
SearchInBackOp()
{
	int res;

	CrtDrawLine(GetRow(), GetLineOffset(), FALSE);
	res = SearchInBack();
	CrtDrawLine(GetRow(), GetLineOffset(), TRUE);
	if (res == TRUE) {
		system_msg(FOUND_MSG);
	} else if (res == FALSE) {
		system_msg(NOT_FOUND_MSG);
	}
}
