/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:setopt.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include <ctype.h>
#include "ed.h"
#include "function.h"

extern char *makeparameter();
static int keyDefNo;
/*-------------------------------------------------------------------
	If set variable "Line Number"  then Check variable "NumWidth"
-------------------------------------------------------------------*/
VOID
CheckLineNumberFlg()
{
	if (LineNumber_flag == TRUE) {
		NumWidth = 6;
	} else {
		NumWidth = 0;
	}
}

/*-------------------------------------------------------------------
	Set Default option's
-------------------------------------------------------------------*/
VOID
SetDefaultOption()
{
	lang = JAPANESE;
	setlang = TRUE;
	CursorMode = STOP;
	Profile_flag = TRUE;
	HistorySave_flag = TRUE;
	HistoryRead_flag = TRUE;
	BackFile_flag = FALSE;
	LineNumber_flag = FALSE;
	AutoIndent_flag = TRUE;
	InputMode_flag = INSERT;
	DirectorySort_flag = TRUE;
	SearchStrCharMode = DIVIDE;
	UnderLine_flag = TRUE;
	Fast_flag = TRUE;
#ifdef	CODEEUC
	Kanji_Code = EUC;
#else
	Kanji_Code = SJIS;
#endif
	TabStop = 8;
	Tab_Space_flg = FALSE;
	TabMark = FALSE;
	RollWidth = 1;
	CrMark = FALSE;
	TabCode = '>';
	CrCode = '$';
	CheckLineNumberFlg();
	SaveHistoryNumber = 20;
	MacroMode = MACRONONE;
}

VOID
SetRollWidth(buffer)
char *buffer;
{
	RollWidth = atoi(buffer);
	if (RollWidth <= 0) {
		RollWidth = 1;
	}
}

/*-------------------------------------------------------------------
	Set TAB Stop
-------------------------------------------------------------------*/

VOID
setTab(buffer)
char *buffer;
{
	TabStop = atoi(buffer);
	if (TabStop == 0) {
		TabStop = 8;
	}
}

VOID
setSaveHisNum(buffer)
char *buffer;
{
	SaveHistoryNumber = atoi(buffer);
	if (SaveHistoryNumber == 0) {
		SaveHistoryNumber = 20;
	}
}

VOID
toggleTab_Space()
{
	if (Tab_Space_flg == TRUE) {
		Tab_Space_flg = FALSE;
	} else {
		Tab_Space_flg = TRUE;
	}
}

/*-------------------------------------------------------------------
	Toggle back FILE flag
-------------------------------------------------------------------*/
VOID
toggleMessageLang()
{
	if (lang == ENGLISH) {
		lang = JAPANESE;
	} else {
		lang = ENGLISH;
	}
}

/*-------------------------------------------------------------------
	Toggle back FILE flag
-------------------------------------------------------------------*/
VOID
toggleCursorMode()
{
	if (CursorMode == STOP) {
		CursorMode = FREE;
	} else {
		CursorMode = STOP;
	}
	ResetCursorPosition();
}

/*-------------------------------------------------------------------
	Toggle back FILE flag
-------------------------------------------------------------------*/
VOID
toggleBackFileFlg()
{
	if (BackFile_flag == TRUE) {
		BackFile_flag = FALSE;
	} else {
		BackFile_flag = TRUE;
	}
}

/*-------------------------------------------------------------------
	Toggle Line Number flag
-------------------------------------------------------------------*/
VOID
toggleLineNumberFlg()
{
	if (LineNumber_flag == TRUE) {
		LineNumber_flag = FALSE;
	} else {
		LineNumber_flag = TRUE;
	}
	CheckLineNumberFlg();
}

/*-------------------------------------------------------------------
	Toggle under line flag
-------------------------------------------------------------------*/
VOID
toggleUnderLineFlg()
{
	if (UnderLine_flag == TRUE) {
		UnderLine_flag = FALSE;
	} else {
		UnderLine_flag = TRUE;
	}
}

/*-------------------------------------------------------------------
	Toggle Fast mode flag
-------------------------------------------------------------------*/
VOID
toggleFastModeFlg()
{
	if (Fast_flag == TRUE) {
		Fast_flag = FALSE;
		/*typeahead(-1);*/
		idlok(stdscr, FALSE);
	} else {
		Fast_flag = TRUE;
		/*typeahead(stdin);*/
		idlok(stdscr, TRUE);
	}
}

/*-------------------------------------------------------------------
	Toggle tab mark flag
-------------------------------------------------------------------*/
VOID
toggleTabMark()
{
	if (TabMark == TRUE) {
		TabMark = FALSE;
	} else {
		TabMark = TRUE;
	}
}

/*-------------------------------------------------------------------
	Toggle cr marc
-------------------------------------------------------------------*/
VOID
toggleCrMark()
{
	if (CrMark == TRUE) {
		CrMark = FALSE;
	} else {
		CrMark = TRUE;
	}
}

/*-------------------------------------------------------------------
	Toggle AutoIndent
-------------------------------------------------------------------*/
VOID
toggleAutoIndent()
{
	if (AutoIndent_flag == TRUE) {
		AutoIndent_flag = FALSE;
	} else {
		AutoIndent_flag = TRUE;
	}
}

/*-------------------------------------------------------------------
	Toggle Profile flag
-------------------------------------------------------------------*/
VOID
toggleProfileFlg()
{
	if (Profile_flag == TRUE) {
		Profile_flag = FALSE;
	} else {
		Profile_flag = TRUE;
	}
}

/*-------------------------------------------------------------------
	Toggle History Save flag
-------------------------------------------------------------------*/
VOID
toggleSaveHistory()
{
	if (HistorySave_flag == TRUE) {
		HistorySave_flag = FALSE;
	} else {
		HistorySave_flag = TRUE;
	}
}

/*-------------------------------------------------------------------
	Toggle History Read flag
-------------------------------------------------------------------*/
VOID
toggleReadHistory()
{
	if (HistoryRead_flag == TRUE) {
		HistoryRead_flag = FALSE;
	} else {
		HistoryRead_flag = TRUE;
	}
}

/*-------------------------------------------------------------------
	Toggle Input mode flag
-------------------------------------------------------------------*/
VOID
toggleInputMode()
{
	if (InputMode_flag == INSERT) {
		InputMode_flag = OVERWRITE;
	} else {
		InputMode_flag = INSERT;
	}
	system_guide();
}

/*-------------------------------------------------------------------
	Toggle Input mode flag
-------------------------------------------------------------------*/
VOID
toggleDirSortFlg()
{
	if (DirectorySort_flag == TRUE) {
		DirectorySort_flag = FALSE;
	} else {
		DirectorySort_flag = TRUE;
	}
}

VOID
toggleSearchStrCharMode()
{
	if (SearchStrCharMode == SAME) {
		SearchStrCharMode = DIVIDE;
	} else {
		SearchStrCharMode = SAME;
	}
}

/*-------------------------------------------------------------------
	This routine is Key customize
		Stile of key define buffer as follow ...
				string = "^?"
				or string = "^?1^?2"
-------------------------------------------------------------------*/
VOID
setKey(keyno, keystring)
register int keyno;
char *keystring;
{
	int c;

	if (keyDefNo < MAXKEYDEF) {
		if (keystring[0] == '^') {
			c = keystring[1];
			if (islower(c)) {
				c += 'A' - 'a';
			}
			keyDefBuff[keyDefNo].key1 = CNTRL(c);
		} else {
			return;
		}
		if (keystring[2] == '^') {
			c = keystring[3];
			if (islower(c)) {
				c += 'A' - 'a';
			}
			keyDefBuff[keyDefNo].key2 = CNTRL(c);
		} else if (keystring[2] != '\0') {
			c = keystring[2];
			if (isalpha(c)) {
				c &= 037;
			}
			keyDefBuff[keyDefNo].key2 = c;
		} else {
			keyDefBuff[keyDefNo].key2 = -1;
		}
		keyDefBuff[keyDefNo].funcNo = keyno;
		keyDefNo++;
	}
}

VOID
setDefKey(keyno, c1, c2)
register int keyno;
int c1, c2;
{
	int i;

	if (keyDefNo >= MAXKEYDEF) {
		return;
	}
	for (i = 0; i < keyDefNo; i++) {
		if (c1 == keyDefBuff[i].key1) {
			if (c2 == keyDefBuff[i].key2
			|| c2 < 0 || keyDefBuff[i].key2 < 0) {
				return;
			}
		}
	}

	keyDefBuff[keyDefNo].funcNo = keyno;
	keyDefBuff[keyDefNo].key1 = c1;
	keyDefBuff[keyDefNo++].key2 = c2;
}

/*-------------------------------------------------------------------
	This routine is Key customize
		Stile of key define buffer as follow ...
				string = "^?"
				or string = "^?1^?2"
-------------------------------------------------------------------*/
VOID
setSyStemKey(keyno, keystring)
register int keyno;
char *keystring;
{
	int c;

	if (keyno < MAXSYSKEYDEF) {
		if (keystring[0] == '^') {
			c = keystring[1];
			if (islower(c)) {
				c += 'A' - 'a';
			}
			SyStemKey[keyno].key1 = CNTRL(c);
		} else {
			if (keystring[0] == '\0') {
				SyStemKey[keyno].key1 = -1;
			}
			return;
		}
		if (keystring[2] == '^') {
			c = keystring[3];
			if (islower(c)) {
				c += 'A' - 'a';
			}
			SyStemKey[keyno].key2 = CNTRL(c);
		} else if (keystring[2] != '\0') {
			c = keystring[2];
			if (isalpha(c)) {
				c &= 037;
			}
			SyStemKey[keyno].key2 = c;
		} else {
			SyStemKey[keyno].key2 = -1;
		}
	}
}

VOID
setDefSyStemKey(keyno, c1, c2)
register int keyno;
int c1, c2;
{
	int i;

	if (keyno >= MAXSYSKEYDEF || SyStemKey[keyno].key1 != -2) {
		return;
	}
	for (i = 0; i < MAXSYSKEYDEF; i++) {
		if (c1 == SyStemKey[i].key1) {
			if (c2 == SyStemKey[i].key2
			|| c2 < 0 || SyStemKey[i].key2 < 0) {
				return;
			}
		}
	}

	SyStemKey[keyno].key1 = c1;
	SyStemKey[keyno].key2 = c2;
}

/*-------------------------------------------------------------------
	Standard Key define and Function Table
-------------------------------------------------------------------*/
VOID
KeyDefInit()
{
	SyStemKey[_CURSORUP].funcNo = KEY_UP;

	SyStemKey[_CURSORDOWN].funcNo = KEY_DOWN;

	SyStemKey[_CURSORLEFT].funcNo = KEY_LEFT;

	SyStemKey[_CURSORRIGHT].funcNo = KEY_RIGHT;

	SyStemKey[_SCROLLDOWN].funcNo = KEY_PPAGE;

	SyStemKey[_SCROLLUP].funcNo = KEY_NPAGE;

	SyStemKey[_ROLLUP].funcNo = KEY_SF;

	SyStemKey[_ROLLDOWN].funcNo = KEY_SR;

	SyStemKey[_RETURN].funcNo = KEY_ENTER;

	SyStemKey[_BACKSPACE].funcNo = KEY_BACKSPACE;

	SyStemKey[_DELETECHAR].funcNo = KEY_DC;

	SyStemKey[_CNTRLINPUT].funcNo = KEY_PRINT;

	SyStemKey[_CURSORUPSIDE].funcNo = KEY_SHOME;

	SyStemKey[_CURSORDOWNSIDE].funcNo = KEY_SEND;

	SyStemKey[_CURSORLEFTSIDE].funcNo = KEY_SLEFT;

	SyStemKey[_CURSORRIGHTSIDE].funcNo = KEY_SRIGHT;

	SyStemKey[_CURSORTOPSIDE].funcNo = KEY_HOME;

	SyStemKey[_CURSORENDSIDE].funcNo = KEY_END;

	SyStemKey[_ESCAPE].funcNo = KEY_CANCEL;

	funcDefBuff[_CURSORUP] = CursorUpOp;
	helpDefBuff[_CURSORUP] = HelpCursorUpOp;

	funcDefBuff[_CURSORDOWN] = CursorDownOp;
	helpDefBuff[_CURSORDOWN] = HelpCursorDownOp;

	funcDefBuff[_CURSORLEFT] = CursorLeftOp;
	helpDefBuff[_CURSORLEFT] = HelpCursorLeftOp;

	funcDefBuff[_CURSORRIGHT] = CursorRightOp;
	helpDefBuff[_CURSORRIGHT] = HelpCursorRightOp;

	funcDefBuff[_SCROLLDOWN] = ScrollDownOp;
	helpDefBuff[_SCROLLDOWN] = HelpScrollDownOp;

	funcDefBuff[_SCROLLUP] = ScrollUpOp;
	helpDefBuff[_SCROLLUP] = HelpScrollUpOp;

	funcDefBuff[_ROLLUP] = RollUpOp;
	helpDefBuff[_ROLLUP] = HelpRollUpOp;

	funcDefBuff[_ROLLDOWN] = RollDownOp;
	helpDefBuff[_ROLLDOWN] = HelpRollDownOp;

	funcDefBuff[_JMPNEXTTOP] = CursorJmpNextTopOp;
	helpDefBuff[_JMPNEXTTOP] = HelpCursorJmpNextTopOp;

	funcDefBuff[_NEXTTOKEN] = NextToken;
	helpDefBuff[_NEXTTOKEN] = HelpNextToken;

	funcDefBuff[_BEFORETOKEN] = BeforeToken;
	helpDefBuff[_BEFORETOKEN] = HelpBeforeToken;

	funcDefBuff[_DELETETOKEN] = DeleteTokenOp;
	helpDefBuff[_DELETETOKEN] = HelpDeleteTokenOp;

	funcDefBuff[_RETURN] = SplitLineOp;
	helpDefBuff[_RETURN] = HelpSplitLineOp;

	funcDefBuff[_NEWLINE] = NewLineOp;
	helpDefBuff[_NEWLINE] = HelpNewLineOp;

	funcDefBuff[_BACKSPACE] = BackSpaceOp;
	helpDefBuff[_BACKSPACE] = HelpBackSpaceOp;

	funcDefBuff[_DELETECHAR] = DeleteOp;
	helpDefBuff[_DELETECHAR] = HelpDeleteOp;

	funcDefBuff[_DELETELINE] = DeleteLineOp;
	helpDefBuff[_DELETELINE] = HelpDeleteLineOp;

	funcDefBuff[_UNDOLINE] = UndoLineOp;
	helpDefBuff[_UNDOLINE] = HelpUndoLineOp;

	funcDefBuff[_DELETETOEND] = DeleteToEnd;
	helpDefBuff[_DELETETOEND] = HelpDeleteToEnd;

	funcDefBuff[_DELETETOTOP] = DeleteToTop;
	helpDefBuff[_DELETETOTOP] = HelpDeleteToTop;

	funcDefBuff[_SEARCHBACK] = SearchBackOp;
	helpDefBuff[_SEARCHBACK] = HelpSearchBackOp;

	funcDefBuff[_SEARCHFORWARD] = SearchForwardOp;
	helpDefBuff[_SEARCHFORWARD] = HelpSearchForwardOp;

	funcDefBuff[_TOGGLEFILE] = toggleFileOp;
	helpDefBuff[_TOGGLEFILE] = HelptoggleFileOp;

	funcDefBuff[_CHANGEFILE] = ChangeFileOp;
	helpDefBuff[_CHANGEFILE] = HelpChangeFileOp;


	funcDefBuff[_CNTRLINPUT] = CntrlInputOp;
	helpDefBuff[_CNTRLINPUT] = HelpCntrlInputOp;

	funcDefBuff[_CURSORLEFTSIDE] = CursorLeftSideOp;
	helpDefBuff[_CURSORLEFTSIDE] = HelpCursorLeftSideOp;

	funcDefBuff[_CURSORRIGHTSIDE] = CursorRightSideOp;
	helpDefBuff[_CURSORRIGHTSIDE] = HelpCursorRightSideOp;

	funcDefBuff[_CURSORUPSIDE] = CursorUpSideOp;
	helpDefBuff[_CURSORUPSIDE] = HelpCursorUpSideOp;

	funcDefBuff[_CURSORDOWNSIDE] = CursorDownSideOp;
	helpDefBuff[_CURSORDOWNSIDE] = HelpCursorDownSideOp;

	funcDefBuff[_CURSORTOPSIDE] = CursorTopSideOp;
	helpDefBuff[_CURSORTOPSIDE] = HelpCursorTopSideOp;

	funcDefBuff[_CURSORENDSIDE] = CursorEndSideOp;
	helpDefBuff[_CURSORENDSIDE] = HelpCursorEndSideOp;

	funcDefBuff[_SEARCHFORWARDINPUT] = SearchInForwardOp;
	helpDefBuff[_SEARCHFORWARDINPUT] = HelpSearchInForwardOp;

	funcDefBuff[_SEARCHBACKINPUT] = SearchInBackOp;
	helpDefBuff[_SEARCHBACKINPUT] = HelpSearchInBackOp;

	funcDefBuff[_BRACKETSEARCH] = BracketSearchOp;
	helpDefBuff[_BRACKETSEARCH] = HelpBracketSearchOp;

	funcDefBuff[_CHANGESTRING] = ChangeStringMenu;
	helpDefBuff[_CHANGESTRING] = HelpChangeStringMenu;

	funcDefBuff[_REPEATCHANGEOP] = RepeatChangeOperation;
	helpDefBuff[_REPEATCHANGEOP] = HelpRepeatChangeOperation;

	funcDefBuff[_BLOCKSTART] = BlockStartOp;
	helpDefBuff[_BLOCKSTART] = HelpBlockStartOp;

	funcDefBuff[_BLOCKYANC] = BlockYancOp;
	helpDefBuff[_BLOCKYANC] = HelpBlockYancOp;

	funcDefBuff[_BLOCKONELINEYANC] = BlockOneLineYancOp;
	helpDefBuff[_BLOCKONELINEYANC] = HelpBlockOneLineYancOp;

	funcDefBuff[_BLOCKDELETE] = BlockDeleteOp;
	helpDefBuff[_BLOCKDELETE] = HelpBlockDeleteOp;

	funcDefBuff[_BLOCKMOVE] = BlockMoveOp;
	helpDefBuff[_BLOCKMOVE] = HelpBlockMoveOp;

	funcDefBuff[_BLOCKPASTE] = BlockPasteOp;
	helpDefBuff[_BLOCKPASTE] = HelpBlockPasteOp;

	funcDefBuff[_CURRENTFILESAVE] = CurrentFileSave;
	helpDefBuff[_CURRENTFILESAVE] = HelpCurrentFileSave;

	funcDefBuff[_ALLFILESAVE] = AllFileSave;
	helpDefBuff[_ALLFILESAVE] = HelpAllFileSave;

	funcDefBuff[_ALLFILESAVE_END] = AllSave_End;
	helpDefBuff[_ALLFILESAVE_END] = HelpAllSave_End;

	funcDefBuff[_FILEOPEN] = SetName_FileOpenOp;
	helpDefBuff[_FILEOPEN] = HelpSetName_FileOpenOp;

	funcDefBuff[_CURRENTFILEEND] = CurrentFileKill;
	helpDefBuff[_CURRENTFILEEND] = HelpCurrentFileKill;

	funcDefBuff[_ALLFILEKILL_END] = AllKill_End;
	helpDefBuff[_ALLFILEKILL_END] = HelpAllKill_End;

	funcDefBuff[_FRESHSTARTFILE] = FreshStartFile;
	helpDefBuff[_FRESHSTARTFILE] = HelpFreshStartFile;

	funcDefBuff[_SYSTEMCOMMAND] = SystemCommandOp;
	helpDefBuff[_SYSTEMCOMMAND] = HelpSystemCommandOp;

	funcDefBuff[_TAGJMP] = tagJmpOp;
	helpDefBuff[_TAGJMP] = HelptagJmpOp;

	funcDefBuff[_SEEOPTIONS] = SeeOptionOp;
	helpDefBuff[_SEEOPTIONS] = HelpSeeOptionOp;


	funcDefBuff[_FILEMENU] = FileMenu;
	helpDefBuff[_FILEMENU] = HelpFileMenu;

	funcDefBuff[_SHELLESCAPE] = ShellEscape;
	helpDefBuff[_SHELLESCAPE] = HelpShellEscape;

	funcDefBuff[_TOGGLELINENUMBER] = toggleLineNumberOp;
	helpDefBuff[_TOGGLELINENUMBER] = HelptoggleLineNumberOp;

	funcDefBuff[_TOGGLEUNDERLINE] = toggleUnderLineOp;
	helpDefBuff[_TOGGLEUNDERLINE] = HelptoggleUnderLineOp;

	funcDefBuff[_TOGGLEFASTMODE] = toggleFastModeFlg;
	helpDefBuff[_TOGGLEFASTMODE] = HelptoggleFastModeFlg;

	funcDefBuff[_TOGGLEAUTOINDENT] = toggleAutoIndent;
	helpDefBuff[_TOGGLEAUTOINDENT] = HelptoggleAutoIndent;

	funcDefBuff[_TOGGLEINPUTMODE] = toggleInputMode;
	helpDefBuff[_TOGGLEINPUTMODE] = HelptoggleInputMode;

	funcDefBuff[_TOGGLECURSORMODE] = toggleCursorMode;
	helpDefBuff[_TOGGLECURSORMODE] = HelptoggleCursorMode;

	funcDefBuff[_MULTIFILESEARCH] = MultiFileSearch;
	helpDefBuff[_MULTIFILESEARCH] = HelpMultiFileSearch;

	funcDefBuff[_MULTIFILECHANGE] = MultiFileChange;
	helpDefBuff[_MULTIFILECHANGE] = HelpMultiFileChange;

	funcDefBuff[_FRESHREDRAW] = FreshRedraw;
	helpDefBuff[_FRESHREDRAW] = HelpFreshRedraw;

	funcDefBuff[_MARKLINE] = MarkLine;
	helpDefBuff[_MARKLINE] = HelpMarkLine;

	funcDefBuff[_MACRO] = SetMacroMode;
	helpDefBuff[_MACRO] = HelpSetMacroMode;

	funcDefBuff[_HELP] = Help;
	helpDefBuff[_HELP] = HelpHelp;
}

VOID
DefaultKeySet()
{
	setDefSyStemKey(_CURSORUP, CNTRL('E'), -1);
	setDefSyStemKey(_CURSORDOWN, CNTRL('X'), -1);
	setDefSyStemKey(_CURSORLEFT, CNTRL('S'), -1);
	setDefSyStemKey(_CURSORRIGHT, CNTRL('D'), -1);
	setDefSyStemKey(_SCROLLDOWN, CNTRL('R'), -1);
	setDefSyStemKey(_SCROLLUP, CNTRL('C'), -1);
	setDefSyStemKey(_ROLLUP, CNTRL('W'), -1);
	setDefSyStemKey(_ROLLDOWN, CNTRL('Z'), -1);
	setDefSyStemKey(_RETURN, CNTRL('M'), -1);
	setDefSyStemKey(_BACKSPACE, CNTRL('H'), -1);
	setDefSyStemKey(_DELETECHAR, CNTRL('G'), -1);
	setDefSyStemKey(_CNTRLINPUT, CNTRL('_'), -1);
	setDefSyStemKey(_CURSORUPSIDE, CNTRL('Q'), CNTRL('E'));
	setDefSyStemKey(_CURSORDOWNSIDE, CNTRL('Q'), CNTRL('X'));
	setDefSyStemKey(_CURSORLEFTSIDE, CNTRL('Q'), CNTRL('S'));
	setDefSyStemKey(_CURSORRIGHTSIDE, CNTRL('Q'), CNTRL('D'));
	setDefSyStemKey(_CURSORTOPSIDE, CNTRL('Q'), CNTRL('R'));
	setDefSyStemKey(_CURSORENDSIDE, CNTRL('Q'), CNTRL('C'));
	setDefSyStemKey(_ESCAPE, CNTRL('['), -1);

	setDefKey(_CURSORUP, CNTRL('E'), -1);
	setDefKey(_CURSORDOWN, CNTRL('X'), -1);
	setDefKey(_CURSORLEFT, CNTRL('S'), -1);
	setDefKey(_CURSORRIGHT, CNTRL('D'), -1);
	setDefKey(_SCROLLDOWN, CNTRL('R'), -1);
	setDefKey(_SCROLLUP, CNTRL('C'), -1);
	setDefKey(_ROLLUP, CNTRL('W'), -1);
	setDefKey(_ROLLDOWN, CNTRL('Z'), -1);
	setDefKey(_JMPNEXTTOP, CNTRL('J'), -1);
	setDefKey(_NEXTTOKEN, CNTRL('F'), -1);
	setDefKey(_BEFORETOKEN, CNTRL('A'), -1);
	setDefKey(_DELETETOKEN, CNTRL('T'), -1);
	setDefKey(_RETURN, CNTRL('M'), -1);
	setDefKey(_NEWLINE, CNTRL('N'), -1);
	setDefKey(_BACKSPACE, CNTRL('H'), -1);
	setDefKey(_DELETECHAR, CNTRL('G'), -1);
	setDefKey(_DELETELINE, CNTRL('Y'), -1);
	setDefKey(_UNDOLINE, CNTRL('P'), CNTRL('U'));
	setDefKey(_DELETETOEND, CNTRL('Q'), CNTRL('G'));
	setDefKey(_DELETETOTOP, CNTRL('Q'), CNTRL('H'));
	setDefKey(_SEARCHBACK, CNTRL('O'), -1);
	setDefKey(_SEARCHFORWARD, CNTRL('L'), -1);
	setDefKey(_TOGGLEFILE, CNTRL('U'), CNTRL('U'));
	setDefKey(_CHANGEFILE, CNTRL('U'), CNTRL('T'));
	setDefKey(_CHANGEFILE, CNTRL('Q'), '2');
	setDefKey(_CNTRLINPUT, CNTRL('_'), -1);
	setDefKey(_CURSORLEFTSIDE, CNTRL('Q'), CNTRL('S'));
	setDefKey(_CURSORRIGHTSIDE, CNTRL('Q'), CNTRL('D'));
	setDefKey(_CURSORUPSIDE, CNTRL('Q'), CNTRL('E'));
	setDefKey(_CURSORDOWNSIDE, CNTRL('Q'), CNTRL('X'));
	setDefKey(_CURSORTOPSIDE, CNTRL('Q'), CNTRL('R'));
	setDefKey(_CURSORENDSIDE, CNTRL('Q'), CNTRL('C'));
	setDefKey(_SEARCHFORWARDINPUT, CNTRL('Q'), CNTRL('F'));
	setDefKey(_SEARCHBACKINPUT, CNTRL('Q'), CNTRL('B'));
	setDefKey(_BRACKETSEARCH, CNTRL(']'), -1);
	setDefKey(_CHANGESTRING, CNTRL('Q'), CNTRL('A'));
	setDefKey(_REPEATCHANGEOP, CNTRL('Q'), CNTRL('P'));
	setDefKey(_BLOCKSTART, CNTRL('K'), CNTRL('B'));
	setDefKey(_BLOCKYANC, CNTRL('K'), CNTRL('K'));
	setDefKey(_BLOCKONELINEYANC, CNTRL('K'), CNTRL('L'));
	setDefKey(_BLOCKDELETE, CNTRL('K'), CNTRL('Y'));
	setDefKey(_BLOCKMOVE, CNTRL('K'), CNTRL('M'));
	setDefKey(_BLOCKPASTE, CNTRL('K'), CNTRL('C'));
	setDefKey(_CURRENTFILESAVE, CNTRL('K'), CNTRL('S'));
	setDefKey(_ALLFILESAVE, CNTRL('K'), CNTRL('W'));
	setDefKey(_ALLFILESAVE_END, CNTRL('K'), CNTRL('E'));
	setDefKey(_FILEOPEN, CNTRL('K'), CNTRL('O'));
	setDefKey(_CURRENTFILEEND, CNTRL('K'), CNTRL('Q'));
	setDefKey(_ALLFILEKILL_END, CNTRL('K'), CNTRL('A'));
	setDefKey(_FRESHSTARTFILE, CNTRL('K'), CNTRL('U'));
	setDefKey(_SYSTEMCOMMAND, CNTRL('['), -1);
	setDefKey(_TAGJMP, CNTRL('Q'), CNTRL('J'));
	setDefKey(_SEEOPTIONS, CNTRL('Q'), CNTRL('O'));
	setDefKey(_SEEOPTIONS, CNTRL('Q'), '3');
	setDefKey(_FILEMENU, CNTRL('Q'), '1');
	setDefKey(_SHELLESCAPE, CNTRL('P'), CNTRL('S'));
	setDefKey(_TOGGLELINENUMBER, CNTRL('Q'), CNTRL('L'));
	setDefKey(_TOGGLEUNDERLINE, CNTRL('Q'), CNTRL('U'));
	setDefKey(_TOGGLEFASTMODE, CNTRL('Q'), CNTRL('K'));
	setDefKey(_TOGGLEAUTOINDENT, CNTRL('Q'), CNTRL('O'));
	setDefKey(_TOGGLEINPUTMODE, CNTRL('V'), -1);
	setDefKey(_TOGGLECURSORMODE, CNTRL('Q'), CNTRL('V'));
	setDefKey(_MULTIFILESEARCH, CNTRL('\\'), -1);
	setDefKey(_MULTIFILECHANGE, CNTRL('^'), -1);
	setDefKey(_FRESHREDRAW, CNTRL('Q'), CNTRL('Q'));
	setDefKey(_MARKLINE, CNTRL('Q'), CNTRL('M'));
	setDefKey(_MACRO, CNTRL('K'), CNTRL('Z'));
	setDefKey(_HELP, CNTRL('Q'), CNTRL('Z'));
}

VOID
ReadDef(path)
char *path;
{
	register FILE *fp;
	char buffer[MAXLINESTR+2];
	char tmpbuff[MAXLINESTR+1];
	int i, len;

	keyDefNo = 0;
	for (i = 0; i < MAXSYSKEYDEF; i++) {
		SyStemKey[i].key1 = -2;
	}

	/*Read "nxedit.def" and Set Option's*/
	if ((fp = fopen(path, "r")) == NULL) {
		DefaultKeySet();
		return;
	}

	while (fgets(buffer, MAXLINESTR+1, fp) != NULL) {
		len = strlen(buffer);
		if (len > 0 && buffer[len-1] == '\n') {
			buffer[--len] = '\0';
		}
		if (!len || buffer[0] == ';' || buffer[0] == '#') {
			continue;
		}
		if (makeparameter(tmpbuff, buffer, "number") != NULL) {
			/*Line Number flag*/
			if (isoption(tmpbuff, "on") == 0) {
				LineNumber_flag = TRUE;
			} else {
				LineNumber_flag = FALSE;
			}
			CheckLineNumberFlg();
		} else if (makeparameter(tmpbuff, buffer, "CursorMode") != NULL) {
			/*Back FILE flag*/
			if (isoption(tmpbuff, "FREE") == 0) {
				CursorMode = FREE;
			} else {
				CursorMode = STOP;
			}
		} else if (makeparameter(tmpbuff, buffer, "backfile") != NULL) {
			/*Back FILE flag*/
			if (isoption(tmpbuff, "on") == 0) {
				BackFile_flag = TRUE;
			} else {
				BackFile_flag = FALSE;
			}
		} else if (makeparameter(tmpbuff, buffer, "profile") != NULL) {
			/*profile flag*/
			if (isoption(tmpbuff, "on") == 0) {
				Profile_flag = TRUE;
			} else {
				Profile_flag = FALSE;
			}
		} else if (makeparameter(tmpbuff, buffer, "SaveHistoryNum") != NULL) {
			/*Save History Number*/
			setSaveHisNum(tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SaveHistory") != NULL) {
			/*Save History flag*/
			if (isoption(tmpbuff, "on") == 0) {
				HistorySave_flag = TRUE;
			} else {
				HistorySave_flag = FALSE;
			}
		} else if (makeparameter(tmpbuff, buffer, "ReadHistory") != NULL) {
			/*Read History flag*/
			if (isoption(tmpbuff, "on") == 0) {
				HistoryRead_flag = TRUE;
			} else {
				HistoryRead_flag = FALSE;
			}
		} else if (makeparameter(tmpbuff, buffer, "underline") != NULL) {
			/*Under line flag*/
			if (isoption(tmpbuff, "on") == 0) {
				UnderLine_flag = TRUE;
			} else {
				UnderLine_flag = FALSE;
			}
		} else if (makeparameter(tmpbuff, buffer, "FastMode") != NULL) {
			/*Under line flag*/
			if (isoption(tmpbuff, "on") == 0) {
				Fast_flag = TRUE;
				/*typeahead(stdin);*/
				idlok(stdscr, TRUE);
			} else {
				Fast_flag = FALSE;
				/*typeahead(-1);*/
				idlok(stdscr, FALSE);
			}
		} else if (makeparameter(tmpbuff, buffer, "crmark") != NULL) {
			/*Cr mark flag*/
			if (isoption(tmpbuff, "on") == 0) {
				CrMark = TRUE;
			} else {
				CrMark = FALSE;
			}
		} else if (makeparameter(tmpbuff, buffer, "tabmark") != NULL) {
			/*Tab mark flag*/
			if (isoption(tmpbuff, "on") == 0) {
				TabMark = TRUE;
			} else {
				TabMark = FALSE;
			}
		} else if (makeparameter(tmpbuff, buffer, "autoindent") != NULL) {
			/*AutoIndent flag*/
			if (isoption(tmpbuff, "on") == 0) {
				AutoIndent_flag = TRUE;
			} else {
				AutoIndent_flag = FALSE;
			}
		} else if (makeparameter(tmpbuff, buffer, "inputmode") != NULL) {
			/*Input Mode flag*/
			if (isoption(tmpbuff, "insert") == 0) {
				InputMode_flag = INSERT;
			} else {
				InputMode_flag = OVERWRITE;
			}
		} else if (makeparameter(tmpbuff, buffer, "DirectorySort") != NULL) {
			/*Input Mode flag*/
			if (isoption(tmpbuff, "on") == 0) {
				DirectorySort_flag = TRUE;
			} else {
				DirectorySort_flag = FALSE;
			}
		} else if (makeparameter(tmpbuff, buffer, "SearchStringMode") != NULL) {
			/*Input Mode flag*/
			if (isoption(tmpbuff, "Same") == 0) {
				SearchStrCharMode = SAME;
			} else {
				SearchStrCharMode = DIVIDE;
			}
		} else if (makeparameter(tmpbuff, buffer, "KanjiCode") != NULL) {
			/*Input Mode flag*/
			if (isoption(tmpbuff, "EUC") == 0) {
				Kanji_Code = EUC;
			} else if (isoption(tmpbuff, "SJIS") == 0) {
				Kanji_Code = SJIS;
			}
		} else if (makeparameter(tmpbuff, buffer, "MessageLang") != NULL) {
			/*Input Mode flag*/
			if (setlang == TRUE) {
				if (isoption(tmpbuff, "Japanese") == 0) {
					lang = JAPANESE;
				} else {
					lang = ENGLISH;
				}
			}
		} else if (makeparameter(tmpbuff, buffer, "Tab_Space") != NULL) {
			/*Tab->Space*/
			if (isoption(tmpbuff, "on") == 0) {
				Tab_Space_flg = TRUE;
			} else {
				Tab_Space_flg = FALSE;
			}
		} else if (makeparameter(tmpbuff, buffer, "tabstop") != NULL) {
			/*Tab Stop*/
			setTab(tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "RollWidth") != NULL) {
			/*Set Roll Width */
			SetRollWidth(tmpbuff);
#if 0
		} else if (makeparameter(tmpbuff, buffer, "crcode") != NULL) {
			/*Cr mark code*/
			sscanf(tmpbuff, "%x", &CrCode);
		} else if (makeparameter(tmpbuff, buffer, "tabcode") != NULL) {
			/*Tab mark code*/
			sscanf(tmpbuff, "%x", &TabCode);
#endif
/*After there is key customize routine */
		} else if (makeparameter(tmpbuff, buffer, "ScrollDown") != NULL) {
			/*scroll down*/
			setKey(_SCROLLDOWN, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "ScrollUp") != NULL) {
			/*scroll up*/
			setKey(_SCROLLUP, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "RollUp") != NULL) {
			/*Roll up*/
			setKey(_ROLLUP, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "RollDown") != NULL) {
			/*Roll up*/
		setKey(_ROLLDOWN, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "JmpNextTop") != NULL) {
			/*Jmp next top*/
			setKey(_JMPNEXTTOP, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "NextToken") != NULL) {
			/*Jmp next token*/
			setKey(_NEXTTOKEN, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "BeforeToken") != NULL) {
			/*Jmp before token */
			setKey(_BEFORETOKEN, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "DeleteToken") != NULL) {
			/*Delete token*/
			setKey(_DELETETOKEN, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "Return") != NULL) {
			/*Return*/
			setKey(_RETURN, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "NewLine") != NULL) {
			/*Insert New Line*/
			setKey(_NEWLINE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "BackSpace") != NULL) {
			/*Back Space*/
			setKey(_BACKSPACE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "DeleteChar") != NULL) {
			/*Delete char*/
			setKey(_DELETECHAR, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "DeleteLine") != NULL) {
			/*Delete Line*/
			setKey(_DELETELINE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "UndoLine") != NULL) {
			/*Undo Line*/
			setKey(_UNDOLINE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "DeleteToEnd") != NULL) {
			/*Delete Cursor Forward*/
			setKey(_DELETETOEND, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "DeleteToTop") != NULL) {
			/*Delete Cursor Back*/
			setKey(_DELETETOTOP, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SearchBack") != NULL) {
			/*Search Before*/
			setKey(_SEARCHBACK, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SearchForward") != NULL) {
			/*Search Forward*/
			setKey(_SEARCHFORWARD, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "BracketSearch") != NULL) {
			/*Bracket Search */
			setKey(_BRACKETSEARCH, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "toggleFile") != NULL) {
			/*Toggle File*/
			setKey(_TOGGLEFILE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "ChangeFile") != NULL) {
			/*Change File*/
			setKey(_CHANGEFILE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "CntrlInput") != NULL) {
			/*Input Control char*/
			setKey(_CNTRLINPUT, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "CursorLeftSide") != NULL) {
			/*Jmp Cursor to Top of line*/
			setKey(_CURSORLEFTSIDE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "CursorRightSide") != NULL) {
			/*Jmp Cursor to Last of line*/
			setKey(_CURSORRIGHTSIDE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "CursorUpSide") != NULL) {
			/*Jmp Cursor to Top of CRT*/
			setKey(_CURSORUPSIDE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "CursorDownSide") != NULL) {
			/*Jmp Cursor to End of CRT*/
			setKey(_CURSORDOWNSIDE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "CursorTopSide") != NULL) {
			/*Jmp Cursor to Top of file*/
			setKey(_CURSORTOPSIDE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "CursorEndSide") != NULL) {
			/*Jmp Cursor to Last of file*/
			setKey(_CURSORENDSIDE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "CursorUp") != NULL) {
			/*cursor up*/
			setKey(_CURSORUP, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "CursorDown") != NULL) {
			/*cursor down*/
			setKey(_CURSORDOWN, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "CursorRight") != NULL) {
			/*cursor right*/
			setKey(_CURSORRIGHT, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "CursorLeft") != NULL) {
			/*cursor left*/
			setKey(_CURSORLEFT, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "tagJmp") != NULL) {
			/*TAG Jmp*/
			setKey(_TAGJMP, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SearchInForward") != NULL) {
			/*Search with Input Search String*/
			setKey(_SEARCHFORWARDINPUT, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SearchInBack") != NULL) {
			/*Search with Input Search String*/
			setKey(_SEARCHBACKINPUT, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "ChangeString") != NULL) {
			/*Replace string*/
			setKey(_CHANGESTRING, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "RepeatChangeOp") != NULL) {
			/*Replace string*/
			setKey(_REPEATCHANGEOP, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "BlockStart") != NULL) {
			/*Start Block mode*/
			setKey(_BLOCKSTART, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "BlockYanc") != NULL) {
			/*Yanc Block*/
			setKey(_BLOCKYANC, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "BlockOneLineYanc") != NULL) {
			/*One Line Yanc Block*/
			setKey(_BLOCKONELINEYANC, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "BlockDelete") != NULL) {
			/*Delete Block*/
			setKey(_BLOCKDELETE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "BlockMove") != NULL) {
			/*Move Block*/
			setKey(_BLOCKMOVE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "BlockPaste") != NULL) {
			/*Paste Block*/
			setKey(_BLOCKPASTE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "CurrentFileSave") != NULL) {
			/*Save Current file*/
			setKey(_CURRENTFILESAVE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "AllFileSave_End") != NULL) {
			/*Save all FILE and End*/
			setKey(_ALLFILESAVE_END, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "AllFileSave") != NULL) {
			/*Save all FILE */
			setKey(_ALLFILESAVE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "AllFileKill_End") != NULL) {
			/*Abandon all FILE and End*/
			setKey(_ALLFILEKILL_END, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "FileOpen") != NULL) {
			/*FILE Open*/
			setKey(_FILEOPEN, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "CurrentFileEnd") != NULL) {
			/*Abandon Current File*/
			setKey(_CURRENTFILEEND, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "FreshStartFile") != NULL) {
			/*Fresh Start Current File*/
			setKey(_FRESHSTARTFILE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SeeOptions") != NULL) {
			/*See Option Menu*/
			setKey(_SEEOPTIONS, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "FileMenu") != NULL) {
			/*FILE Menu */
			setKey(_FILEMENU, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SystemCommand") != NULL) {
			/*System Command*/
			setKey(_SYSTEMCOMMAND, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "ShellEscape") != NULL) {
			/*Shell Escape*/
			setKey(_SHELLESCAPE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "toggleCursorMode") != NULL) {
			setKey(_TOGGLECURSORMODE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "toggleLineNumberKey") != NULL) {
			setKey(_TOGGLELINENUMBER, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "toggleUnderLine") != NULL) {
			setKey(_TOGGLEUNDERLINE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "toggleFastMode") != NULL) {
			setKey(_TOGGLEFASTMODE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "toggleAutoIndent") != NULL) {
			setKey(_TOGGLEAUTOINDENT, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "toggleInputMode") != NULL) {
			setKey(_TOGGLEINPUTMODE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "MultiFileSearch") != NULL) {
			setKey(_MULTIFILESEARCH, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "MultiFileChange") != NULL) {
			setKey(_MULTIFILECHANGE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "FreshRedraw") != NULL) {
			setKey(_FRESHREDRAW, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "MarkLine") != NULL) {
			setKey(_MARKLINE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "MacroSetKey") != NULL) {
			setKey(_MACRO, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "KeyHelp") != NULL) {
			setKey(_HELP, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysScrolldown") != NULL) {
			setSyStemKey(_SCROLLDOWN, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysScrollup") != NULL) {
			setSyStemKey(_SCROLLUP, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysRollup") != NULL) {
			setSyStemKey(_ROLLUP, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysRolldown") != NULL) {
			setSyStemKey(_ROLLDOWN, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysReturn") != NULL) {
			setSyStemKey(_RETURN, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysBackspace") != NULL) {
			setSyStemKey(_BACKSPACE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysDeletechar") != NULL) {
			setSyStemKey(_DELETECHAR, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysCntrlinput") != NULL) {
			setSyStemKey(_CNTRLINPUT, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysCursorupside") != NULL) {
			setSyStemKey(_CURSORUPSIDE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysCursordownside") != NULL) {
			setSyStemKey(_CURSORDOWNSIDE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysCursorleftside") != NULL) {
			setSyStemKey(_CURSORLEFTSIDE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysCursorrightside") != NULL) {
			setSyStemKey(_CURSORRIGHTSIDE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysCursortopside") != NULL) {
			setSyStemKey(_CURSORTOPSIDE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysCursorendside") != NULL) {
			setSyStemKey(_CURSORENDSIDE, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysCursorup") != NULL) {
			setSyStemKey(_CURSORUP, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysCursordown") != NULL) {
			setSyStemKey(_CURSORDOWN, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysCursorleft") != NULL) {
			setSyStemKey(_CURSORLEFT, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysCursorright") != NULL) {
			setSyStemKey(_CURSORRIGHT, tmpbuff);
		} else if (makeparameter(tmpbuff, buffer, "SysEscape") != NULL) {
			setSyStemKey(_ESCAPE, tmpbuff);
		}
	}
	fclose(fp);
	DefaultKeySet();
}

/*-------------------------------------------------------------------
	Read User key costomize and key define or set option's
-------------------------------------------------------------------*/
VOID
ReadDefFile()
{
	char pathbuff[MAXPATHLEN+1];

	sprintf(pathbuff, "%s/.nxrc", NxDEFPath);
	ReadDef(pathbuff);
}

/*-------------------------------------------------------------------
	See Option and Set
-------------------------------------------------------------------*/
static int m_select = 0;
VOID
SeeOption()
{
	char tmpbuff[20][MAXLINESTR+1];
	char *buffer[20];
	char buff[MAXLINESTR+1];
	register int res;
	res = m_select;
	do {
		sprintf(tmpbuff[0], "%s%-12s", OPT_NUMBER_MSG, (LineNumber_flag ? "ON":"OFF"));
		sprintf(tmpbuff[1], "%s%-12s", OPT_INPUT_MODE_MSG, (InputMode_flag == INSERT ? "Insert":"OverWrite"));
		sprintf(tmpbuff[2], "%s%-12s", OPT_CURSOR_MODE_MSG, (CursorMode == STOP ? "STOP":"FREE"));
		sprintf(tmpbuff[3], "%s%-12s", OPT_AUTOINDENT_MODE_MSG, (AutoIndent_flag ? "ON":"OFF"));
		sprintf(tmpbuff[4], "%s%-12s", OPT_UNDERLINE_MSG, (UnderLine_flag ? "ON":"OFF"));
		sprintf(tmpbuff[5], "%s%-12s", OPT_PROFILE_MSG, (Profile_flag ? "ON":"OFF"));
		sprintf(tmpbuff[6], "%s%-12s", OPT_SAVEHISTORY_MSG, (HistorySave_flag ? "ON":"OFF"));
		sprintf(tmpbuff[7], "%s%-12s", OPT_BACKUP_MSG, (BackFile_flag ? "ON":"OFF"));
		sprintf(tmpbuff[8], "%s%-12s", OPT_TAB_MARK_MSG, (TabMark ? "ON":"OFF"));
		sprintf(tmpbuff[9], "%s%-12s", OPT_TAB_SPACE_MSG, (Tab_Space_flg ? "ON":"OFF"));
		sprintf(tmpbuff[10], "%s%-12s", OPT_CR_MARK_MSG, (CrMark ? "ON":"OFF"));
		sprintf(tmpbuff[11], "%s%-12s", OPT_FAST_MODE_MSG, (Fast_flag ? "ON":"OFF"));
		sprintf(tmpbuff[12], "%s%-12s", OPT_DIR_SORT_MSG, (DirectorySort_flag ? "ON":"OFF"));
		sprintf(tmpbuff[13], "%s%-12s", OPT_SEARCH_CH_MSG, (SearchStrCharMode == SAME ? "Same":"Divide"));
		sprintf(tmpbuff[14], "%s%-12s", OPT_MESSAGE_MSG, (lang == JAPANESE ? "JAPANESE":"ENGLISH"));
		sprintf(tmpbuff[15], "%s%-12s", OPT_KANJICODE_MSG, (Kanji_Code == EUC ? "EUC":(Kanji_Code == SJIS ? "SJIS": "JIS")));
		sprintf(tmpbuff[16], "%s%-12d", OPT_TAB_STOP_MSG, TabStop);

		buffer[0] = tmpbuff[0];
		buffer[1] = tmpbuff[1];
		buffer[2] = tmpbuff[2];
		buffer[3] = tmpbuff[3];
		buffer[4] = tmpbuff[4];
		buffer[5] = tmpbuff[5];
		buffer[6] = tmpbuff[6];
		buffer[7] = tmpbuff[7];
		buffer[8] = tmpbuff[8];
		buffer[9] = tmpbuff[9];
		buffer[10] = tmpbuff[10];
		buffer[11] = tmpbuff[11];
		buffer[12] = tmpbuff[12];
		buffer[13] = tmpbuff[13];
		buffer[14] = tmpbuff[14];
		buffer[15] = tmpbuff[15];
		buffer[16] = tmpbuff[16];

		NumMenu_open(GetMinRow(), GetMinCol(), buffer, 17);
		res = NumMenu_select(GetMinRow(), GetMinCol(), buffer, 17, res);
		switch(res) {
		case 0:
			toggleLineNumberFlg();
			m_select = res;
			break;
		case 1:
			toggleInputMode();
			m_select = res;
			break;
		case 2:
			toggleCursorMode();
			m_select = res;
			break;
		case 3:
			toggleAutoIndent();
			m_select = res;
			break;
		case 4:
			toggleUnderLineFlg();
			m_select = res;
			break;
		case 5:
			toggleProfileFlg();
			m_select = res;
			break;
		case 6:
			toggleSaveHistory();
			m_select = res;
			break;
		case 7:
			toggleBackFileFlg();
			m_select = res;
			break;
		case 8:
			toggleTabMark();
			m_select = res;
			break;
		case 9:
			toggleTab_Space();
			m_select = res;
			break;
		case 10:
			toggleCrMark();
			m_select = res;
			break;
		case 11:
			toggleFastModeFlg();
			m_select = res;
			break;
		case 12:
			toggleDirSortFlg();
			m_select = res;
			break;
		case 13:
			toggleSearchStrCharMode();
			m_select = res;
			break;
		case 14:
			toggleMessageLang();
			m_select = res;
			break;
		case 15:
			if (Kanji_Code == EUC) {
				Kanji_Code = SJIS;
			} else {
				Kanji_Code = EUC;
			}
			m_select = res;
			break;
		case 16:
			buff[0] = '\0';
			if (GetS(GETS_TAB_STOP_MSG, buff) != ESCAPE) {
				setTab(buff);
			}
			m_select = res;
			break;
		}
		CrtDrawAll();
	} while (res != -1);
}

int
GetMaxKeyDef()
{
	return keyDefNo;
}

VOID
SeeOptionOp()
{
	SeeOption();
}
