/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:sysline.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include <ctype.h>
#include "ed.h"

/*-------------------------------------------------------------------
	xchg a b
-------------------------------------------------------------------*/
VOID
xchg(a, b)
register long *a;
register long *b;
{
	register long tmp;
	if (*a > *b) {
		tmp = *a;
		*a = *b;
		*b = tmp;
	}
}

VOID
RefreshMessage()
{
	if (OnMessage_Flag == TRUE) {
		OnMessage_Flag = FALSE;
		BelowLineDraw();
	}
}

/*-------------------------------------------------------------------
	Puts system line
-------------------------------------------------------------------*/
VOID
system_line(message)
char *message;
{
	OnMessage_Flag = TRUE;
	move(GetMaxRow(), GetMinCol());
	clrtoeol();
	CrtNormal(stdscr);
	printw("%-.*s", GetColWidth(), message);
	garbagedlines(stdscr, GetMaxRow(), 1);
	refresh();
}

/*-------------------------------------------------------------------
	Puts system line and Message
-------------------------------------------------------------------*/
VOID
system_msg(buffer)
char *buffer;
{
	OnMessage_Flag = TRUE;
	move(GetMaxRow(), GetMinCol());
	clrtoeol();
	CrtNormal(stdscr);
	if (*buffer != '\0') {
		CrtBold(stdscr);
		printw("%-.*s", GetColWidth(), buffer);
	}
	garbagedlines(stdscr, GetMaxRow(), 1);
	move(GetMaxRow(), GetMinCol()+strlen(buffer));
	CrtNormal(stdscr);
	refresh();
}

int
WarningCheck(buffer)
char *buffer;
{
	OnMessage_Flag = TRUE;
	flash();
	return UserIsYes(buffer);
}

int
UserIsYes(buffer)
char *buffer;
{
	register int c;
	char tmpbuff[MAXLINESTR+1];

	OnMessage_Flag = TRUE;
	sprintf(tmpbuff, "%s... ? (y/n or ESC) :", buffer);
	system_msg(tmpbuff);
	do {
		c = inkey();
	} while (c != 'Y' && c != 'y' && c != 'N' && c != 'n' && c != '\n' && c != '\r' && c != ' ' && c != 0x1b);

	switch (c) {
	case 'Y':
	case 'y':
	case '\r':
	case '\n':
		BelowLineDraw();
		return TRUE;
	case 'N':
	case 'n':
	case ' ':
		BelowLineDraw();
		return FALSE;
	case 0x1b:
		BelowLineDraw();
		return ESCAPE;
	}

	return TRUE;
}

int
WhileKbHit(buffer)
char *buffer;
{
	register int c;
	system_msg(buffer);
	c = inkey();
	return c;

}

/*-------------------------------------------------------------------
	Input String on System Line
-------------------------------------------------------------------*/
int
GetS(message, buffer)
char *message;
char *buffer;
{
	register int res;

	system_line(message);
	res = scanfs(GetMaxRow(), strlen(message), buffer, GetColWidth()-strlen(message), MAXLINESTR);
	if (res == ESCAPE) {
		BelowLineDraw();
	}
	return res;
}

int
IsNumber(buffer)
char *buffer;
{
	register int i;
	if (*buffer == '\0') {
		return FALSE;
	}
	for (i = 0; i < strlen(buffer); i++) {
		if (!isdigit(buffer[i])) {
			return FALSE;
		}
	}
	return TRUE;
}

int
isoption(buffer, option)
char *buffer;
char *option;
{
	register int i;
	int c1, c2;

	for (i = 0; option[i] && buffer[i]; i++) {
		c1 = option[i];
		c2 = buffer[i];
		if (islower(c1)) c1 += 'A' - 'a';
		if (islower(c2)) c2 += 'A' - 'a';
		if (c1 != c2) {
			return c1 - c2;
		}
	}
	return option[i];
}

char *
makeparameter(optbuff, buffer, option)
char *optbuff;
char *buffer;
char *option;
{
	register int i;
	register int j;
	int c1, c2;

	for (i = 0; option[i] && buffer[i]; i++) {
		c1 = option[i];
		c2 = buffer[i];
		if (islower(c1)) c1 += 'A' - 'a';
		if (islower(c2)) c2 += 'A' - 'a';
		if (c1 != c2) {
			return NULL;
		}
	}
	if (option[i]) {
		return NULL;
	}

	for (; buffer[i]; i++) {
		if (buffer[i] != ' ' && buffer[i] != '=' && buffer[i] != '\t') {
			break;
		}
	}
	for (j = 0; i < MAXLINESTR && buffer[i]; i++, j++) {
		optbuff[j] = buffer[i];
	}
	optbuff[j] = '\0';
	return optbuff;
}

int
SystemCommand(buffer)
char *buffer;
{
	register int tmpflg;
	char tmpbuff[MAXLINESTR+1];
	int i;

	if (isoption(buffer, "number") == 0) {
		/*Line Number On/Off */
		toggleLineNumberFlg();
	} else if (isoption(buffer, "underline") == 0) {
		/*Under Line On/Off*/
		toggleUnderLineFlg();
	} else if (isoption(buffer, "autoindent") == 0) {
		/*Auto Indent On/Off*/
		toggleAutoIndent();
	} else if (isoption(buffer, "backfile") == 0) {
		/*Back up FILE On/Off*/
		toggleBackFileFlg();
	} else if (isoption(buffer, "crmark") == 0) {
		/*CR mark On/Off*/
		toggleCrMark();
	} else if (isoption(buffer, "tabmark") == 0) {
		/*TAB mark On/Off*/
		toggleTabMark();
	} else if (makeparameter(tmpbuff, buffer, "tabstop") != NULL) {
		/*Set TAB Stop*/
		setTab(tmpbuff);
	} else if (isoption(buffer, "set") == 0) {
		/*Watch Enviroment*/
		SeeOption();
	} else if (makeparameter(tmpbuff, buffer, "!") != NULL) {
		/*Escape Shell*/
		ShellEscapeStr(tmpbuff);
	} else if (makeparameter(tmpbuff, buffer, "r") != NULL) {
		/*Rename File*/
		RenameFile(CurrentFileNo, tmpbuff);
	} else if (makeparameter(tmpbuff, buffer, "f") != NULL) {
		/*Change File*/
		if (IsNumber(tmpbuff) == TRUE && (i = atoi(tmpbuff)) > 0) {
			i += FILE_START - 1;
			if (EditPathName[i][0] != '\0') {
				BackFileNo = CurrentFileNo;
				CurrentFileNo = i;
			}
		}
	} else if (makeparameter(tmpbuff, buffer, "o") != NULL) {
		/*FILE Open*/
		system_msg(WAITING_MSG);
		FileOpenOp(tmpbuff, 0);
	} else if (isoption(buffer, "a") == 0) {
		/*ALL files KILL and END*/
		AllKill_End();
		EndProcedure();
	} else if (isoption(buffer, "e") == 0) {
		/*ALL files SAVE and END*/
		AllSave_End();
		EndProcedure();
	} else if (isoption(buffer, "s") == 0) {
		/*Current FILE save*/
		CurrentFileSave();
	} else if (makeparameter(tmpbuff, buffer, "w") != NULL) {
		/*Current FILE Save as..*/
		tmpflg = FileChg_flag[CurrentFileNo];
		SetFileChangeFlag();
		filesave(tmpbuff);
		FileChg_flag[CurrentFileNo] = tmpflg;
	} else if (isoption(buffer, "q") == 0) {
		/*Current FILE KILL*/
		CurrentFileKill();
	} else if (IsNumber(buffer) == TRUE) {
		JmpNumberStr(buffer);
	}
	CrtDrawAll();
	return TRUE;
}

/*-------------------------------------------------------------------
	Put Guide Line
------------------------------------------------------------------*/
VOID
system_guide()
{
	char *buf;
	register int length;

	if (FILE_START <= CurrentFileNo) {
		move(0, 0);
		CrtNormal(stdscr);
		if (28 < GetColWidth()) {
			buf = EditPathName[CurrentFileNo];
			length = strlen(buf);
			if (GetMaxCol()-28 < length) {
				buf = buf + (length - (GetMaxCol()-28));
			}
			CrtReverse(stdscr);
			printw("| NxEditor | %c%c%3d:"
				, (Permission[CurrentFileNo] ? 'R':' ')
				, (FileChg_flag[CurrentFileNo] ? '*':' ')
				, (CurrentFileNo-FILE_START+1));
			widthputs(buf, (GetMaxCol()-28));
			addstr("         ");
			move(0, GetMaxCol()-8);
			if (InputMode_flag == INSERT) {
				CrtReverse(stdscr);
				addstr("[Ins]");
			} else {
				CrtNormal(stdscr);
				addstr("[Rep]");
			}
			if (stable_standout) {
				CrtReverse(stdscr);
				move(0, GetMaxCol());
			}
		} else {
			CrtReverse(stdscr);
			widthputs("", GetMaxCol());
		}
	}
}
